// DlgBan.cpp : implementation file

#include "stdafx.h"
#include "mchat.h"
#include "DlgBan.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CDlgBan dialog

CDlgBan::CDlgBan(FrameChan* pFrame, CDlgBan** ppThis, UINT nTitleID, char cOperation)
	: CDialog(CDlgBan::IDD, pFrame)
{
	//{{AFX_DATA_INIT(CDlgBan)
	//}}AFX_DATA_INIT

	m_pFrame = pFrame;
	m_ppThis = ppThis;
	*m_ppThis = this;
	m_nTitleID = nTitleID;
	m_cOperation = cOperation;

	m_arAdd.SetSize(0, 10);
	m_arDel.SetSize(0, 10);

	m_nCmdCount = 0;

	Create(CDlgBan::IDD, pFrame);
}

void CDlgBan::Append(LPCTSTR pStr)
{
	m_lsBan.AddString(pStr);
}

void CDlgBan::Delete(LPCTSTR pStr)
{
	int n = m_lsBan.FindStringExact(-1, pStr);
	if (n >= 0)
		m_lsBan.DeleteString(n);
}

void CDlgBan::Send(const BOOL fPlus, const CString& s)
{
	if (m_nCmdCount == 0) {
		m_sOpt = (m_fPlus = fPlus) ? '+' : '-';
		m_sParm.Empty();
	} else {
		if (m_fPlus != fPlus)
			m_sOpt += ((m_fPlus = fPlus) ? '+' : '-');
		m_sParm += ' ';
	}
	m_sOpt += m_cOperation;
	m_sParm += s;
	if (++m_nCmdCount >= 3)
		Flush();
}

void CDlgBan::Flush()
{
	if (m_nCmdCount) {
		Cmd("MODE", m_pFrame->m_sTarget, m_sOpt, m_sParm);
		m_nCmdCount = 0;
	}
}

void CDlgBan::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgBan)
	DDX_Control(pDX, IDOK, m_btOK);
	DDX_Control(pDX, IDC_BAN_ENTER, m_edBan);
	DDX_Control(pDX, IDC_BAN_LIST, m_lsBan);
	DDX_Control(pDX, IDC_BAN_DEL, m_btDel);
	DDX_Control(pDX, IDC_BAN_ADD, m_btAdd);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgBan, CDialog)
	//{{AFX_MSG_MAP(CDlgBan)
	ON_EN_CHANGE(IDC_BAN_ENTER, OnChangeBanEnter)
	ON_LBN_SELCHANGE(IDC_BAN_LIST, OnSelchangeBanList)
	ON_BN_CLICKED(IDC_BAN_ADD, OnBanAdd)
	ON_BN_CLICKED(IDC_BAN_DEL, OnBanDel)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CDlgBan message handlers

void CDlgBan::PostNcDestroy() 
{
	delete this;
}

void CDlgBan::OnCancel() 
{
	DestroyWindow();
}

void CDlgBan::OnOK() 
{
	int i;
	for (i = 0; i < m_arDel.GetSize(); i++)
		Send(FALSE, m_arDel[i]);
	for (i = 0; i < m_arAdd.GetSize(); i++)
		Send(TRUE, m_arAdd[i]);
	Flush();

	DestroyWindow();
}

void CDlgBan::OnChangeBanEnter() 
{
	m_btAdd.EnableWindow(m_edBan.LineLength() > 0);
	m_btDel.EnableWindow(FALSE);
}

void CDlgBan::OnSelchangeBanList() 
{
	m_btAdd.EnableWindow(FALSE);
	m_btDel.EnableWindow(m_lsBan.GetSelCount() > 0);
}

static int FindString(const CString& s, const CStringArray& ar)
{
	int i;
	for (i = 0; i < ar.GetSize(); i++)
		if (ar[i] == s)
			return i;
	return -1;
}

void CDlgBan::OnBanAdd() 
{
	CString s;
	m_edBan.GetWindowText(s);
	if (HaveSpace(s)) {
		AfxMessageBox(IDS_MSG_ENTER_NOSPACE,
			MB_OK|MB_APPLMODAL|MB_ICONINFORMATION);
		return;
	}
	if (!s.IsEmpty()) {
		m_lsBan.AddString(s);
		int j = FindString(s, m_arDel);
		if (j >= 0) {
			m_arDel.RemoveAt(j);
			return;
		}
		m_arAdd.Add(s);
		m_edBan.SetWindowText("");
	}
	m_btAdd.EnableWindow(FALSE);
}

void CDlgBan::OnBanDel() 
{
	int i;
	for (i = m_lsBan.GetCount() - 1; i >= 0; i--) {
		if (m_lsBan.GetSel(i) <= 0)
			continue;
		CString s;
		m_lsBan.GetText(i, s);
		m_lsBan.DeleteString(i);
		if (m_edBan.GetWindowTextLength() <= 0)
			m_edBan.SetWindowText(s);
		int j = FindString(s, m_arAdd);
		if (j >= 0)
			m_arAdd.RemoveAt(j);
		else
			m_arDel.Add(s);
	}
	m_btDel.EnableWindow(FALSE);
}

void CDlgBan::OnDestroy() 
{
	*m_ppThis = 0;
	CDialog::OnDestroy();
}

BOOL CDlgBan::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CString s;
	s.LoadString(m_nTitleID);
	SetWindowText(s);

	return TRUE;
}
