// dlgchsw.cpp : implementation file

#include "stdafx.h"
#include "mchat.h"
#include "dlgchsw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CDlgChanSwitch dialog

CDlgChanSwitch::CDlgChanSwitch(FrameChan* pFrame)
	: CDialog(CDlgChanSwitch::IDD, pFrame)
{
	m_pFrame = pFrame;
	m_mode = pFrame->m_mode;

	//{{AFX_DATA_INIT(CDlgChanSwitch)
	m_fLimit = (m_mode.m_nLimit != 0);
	m_nLimit = m_mode.m_nLimit;
	m_fPrivate = m_mode.m_fPrivate;
	m_fSecret = m_mode.m_fSecret;
	m_fInviteOnly = m_mode.m_fInviteOnly;
	m_fTopicOp = m_mode.m_fTopicOp;
	m_fNoOutside = m_mode.m_fNoOutside;
	m_fModerated = m_mode.m_fModerated;
	m_fKey = !m_mode.m_sKey.IsEmpty();
	m_sKey = m_mode.m_sKey;
	m_fKeep = (pFrame->m_pModeKeep != 0);
	m_fAnonymous = m_mode.m_fAnonymous;
	m_fReop = m_mode.m_fReop;
	//}}AFX_DATA_INIT

	if (Create(CDlgChanSwitch::IDD, pFrame))
		pFrame->m_pDlgChanSwitch = this;
}


void CDlgChanSwitch::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgChanSwitch)
	DDX_Check(pDX, IDC_LIMIT, m_fLimit);
	DDX_Text(pDX, IDC_NUM_LIMIT, m_nLimit);
	DDX_Check(pDX, IDC_PRIVATE, m_fPrivate);
	DDX_Check(pDX, IDC_SECRET, m_fSecret);
	DDX_Check(pDX, IDC_INVITE_ONLY, m_fInviteOnly);
	DDX_Check(pDX, IDC_TOPIC_OP, m_fTopicOp);
	DDX_Check(pDX, IDC_NOMSG_OUTSIDE, m_fNoOutside);
	DDX_Check(pDX, IDC_MODERATED, m_fModerated);
	DDX_Check(pDX, IDC_CHANKEY, m_fKey);
	DDX_Text(pDX, IDC_KEYWORD, m_sKey);
	DDX_Check(pDX, IDC_CHSW_KEEP, m_fKeep);
	DDX_Check(pDX, IDC_ANONYMOUS, m_fAnonymous);
	DDX_Check(pDX, IDC_REOP, m_fReop);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDlgChanSwitch, CDialog)
	//{{AFX_MSG_MAP(CDlgChanSwitch)
	ON_BN_CLICKED(IDC_PRIVATE, OnPrivate)
	ON_BN_CLICKED(IDC_SECRET, OnSecret)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CDlgChanSwitch message handlers

void CDlgChanSwitch::OnCancel() 
{
	DestroyWindow();
}

void CDlgChanSwitch::PostNcDestroy() 
{
	m_pFrame->m_pDlgChanSwitch = 0;
	delete this;
}

void CDlgChanSwitch::OnOK() 
{
	if (!UpdateData(TRUE))
		return;

	m_mode.m_fPrivate = m_fPrivate;
	m_mode.m_fSecret = m_fSecret;
	m_mode.m_fInviteOnly = m_fInviteOnly;
	m_mode.m_fTopicOp = m_fTopicOp;
	m_mode.m_fNoOutside = m_fNoOutside;
	m_mode.m_fModerated = m_fModerated;
	m_mode.m_fAnonymous = m_fAnonymous;
	m_mode.m_fReop = m_fReop;
	m_mode.m_nLimit = m_fLimit ? m_nLimit : 0;
	if (m_fKey)
		m_mode.m_sKey = m_sKey;
	else
		m_mode.m_sKey.Empty();

	m_pFrame->ModeChange(&m_mode, m_fKeep);

	DestroyWindow();
}

void CDlgChanSwitch::OnPrivate() 
{
	BOOL fPrivate = ((CButton*)GetDlgItem(IDC_PRIVATE))->GetCheck();
	BOOL fSecret = ((CButton*)GetDlgItem(IDC_SECRET))->GetCheck();
	if (fPrivate && fSecret)
		((CButton*)GetDlgItem(IDC_SECRET))->SetCheck(0);
}

void CDlgChanSwitch::OnSecret() 
{
	BOOL fPrivate = ((CButton*)GetDlgItem(IDC_PRIVATE))->GetCheck();
	BOOL fSecret = ((CButton*)GetDlgItem(IDC_SECRET))->GetCheck();
	if (fPrivate && fSecret)
		((CButton*)GetDlgItem(IDC_PRIVATE))->SetCheck(0);
}
