// DlgDcc.h : header file
//

#include "dcc.h"

// CDlgDcc dialog

class CDlgDcc : public CDialog
{
// Construction
public:
	CDlgDcc(int nType, CWnd* pParent = NULL);   // standard constructor

	enum { TypeSnd, TypeRcv };

// operation
public:
	BOOL OpenFile(LPCTSTR psFile, u_long ulSize = 0);
	BOOL DoListen(u_short& usPort); //send
	BOOL DoConnect(u_long ulHost, u_short usPort); //receive

	UINT GetFileSize() //for send
	{
		return m_nSize;
	}

	CString m_sFile;

// Dialog Data
	//{{AFX_DATA(CDlgDcc)
	enum { IDD = IDD_DCC };
	CProgressCtrl	m_pcSize;
	CStatic	m_stFilename;
	CStatic	m_stStatus;
	CStatic	m_stFileSize;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDlgDcc)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	int m_nType;
	BOOL m_fConnect;
	CFile m_file;
	CSockListen m_sockListen;
	CSockData m_sockData;
	UINT m_nSize;				// file size total
	UINT m_nBytes;				// sent or received size
	UINT m_nBytesComplete;		// transfered size
	UINT m_nBytesPerSec;		// transfer rate
	UINT m_nSecond;				// transfering time past
	UINT m_nPrecedePackets;		// proceding packets
	char m_aBuf[1024];
	UINT m_nTMIDSec;		// timer-id for showing speed
	UINT m_nTMIDFinished;	// timer-id to wait user's ack after finish

	void Msg(LPCTSTR pStr);
	void DoSend();
	void ShowSize();
	void Finished();
	void SendAck();
	void SlowClose();

	// Generated message map functions
	//{{AFX_MSG(CDlgDcc)
	afx_msg LONG OnSock(UINT wParam, LONG lParam);
	afx_msg LONG OnSockData(UINT wParam, LONG lParam);
	virtual void OnCancel();
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
