// DlgMisc.cpp : Cve[V t@C

#include "stdafx.h"
#include "mchat.h"
#include "DlgMisc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CIsonPop* CIsonPop::m_pWin = 0;

void CIsonPop::Nick(LPCTSTR pszNick, BOOL fAdd /*=TRUE*/)
{
	if (fAdd)
		Show();

	if (!m_pWin)
		return;

	if (fAdd) {
		if (m_pWin->AddNick(pszNick))
			optBeep.Play(BEEP_FoundNick);
	} else
		m_pWin->DelNick(pszNick);
}

void CIsonPop::Show(bool fShow)
{
	if (fShow) {
		if (m_pWin) {
			m_pWin->SetWindowPos(&CWnd::wndTop,
				0, 0, 0, 0, SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE);
		} else
			m_pWin = new CIsonPop();
	} else if (m_pWin)
		m_pWin->SendMessage(WM_CLOSE);
}

// CIsonPop

#define DEF_SIZE		140

static char szSec[] = _T("Window");
static char szEntry[] = _T("IsOn");
static char szFmtWindowRect[] = "%d,%d,%d,%d";

CIsonPop::CIsonPop()
{
	//{{AFX_DATA_INIT(CIsonPop)
	//}}AFX_DATA_INIT

	CRect rc;
	CRect rcDesk;
	CWnd::GetDesktopWindow()->GetWindowRect(&rcDesk);
	CString s = theApp.GetProfileString(szSec, szEntry);
	if (!s.IsEmpty() &&
			sscanf(s, szFmtWindowRect,
				&rc.left, &rc.top,
				&rc.right, &rc.bottom) == 4) {
		if (rc.left >= rcDesk.right)
			rc.OffsetRect(rcDesk.right - rc.right, 0);
		if (rc.top >= rcDesk.bottom)
			rc.OffsetRect(0, rcDesk.bottom - rc.bottom);
	} else {
		rc.SetRect(rcDesk.right - DEF_SIZE,
			rcDesk.bottom - DEF_SIZE,
			rcDesk.right, rcDesk.bottom);
	}
	LPCTSTR pClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS,
		0, (HBRUSH)(COLOR_INACTIVECAPTION+1));
	VERIFY(CreateEx(WS_EX_TOOLWINDOW,
		pClass, "ISON", WS_POPUP|WS_THICKFRAME|WS_BORDER,
		rc.left, rc.top, rc.Width(), rc.Height(),
		NULL, NULL));
}

BOOL CIsonPop::AddNick(LPCTSTR pszNick)
{
	int n = m_lbNick.FindStringExact(-1, pszNick);
	if (n >= 0)
		return FALSE;
	m_lbNick.AddString(pszNick);
	return TRUE;
}

BOOL CIsonPop::DelNick(LPCTSTR pszNick)
{
	int n = m_lbNick.FindStringExact(-1, pszNick);
	if (n < 0)
		return FALSE;
	m_lbNick.DeleteString(n);
	return TRUE;
}

void CIsonPop::DoDataExchange(CDataExchange* pDX)
{
	CWnd::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIsonPop)
	DDX_Control(pDX, IDC_NICKLIST, m_lbNick);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CIsonPop, CWnd)
	//{{AFX_MSG_MAP(CIsonPop)
	ON_LBN_DBLCLK(IDC_NICKLIST, OnDblclkNicklist)
	ON_LBN_SELCHANGE(IDC_NICKLIST, OnSelchangeNicklist)
	ON_WM_DESTROY()
	ON_WM_CONTEXTMENU()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_WM_NCHITTEST()
	ON_COMMAND(ID_CLOSE, OnClose)
	ON_COMMAND(ID_WHOIS, OnWhois)
	ON_COMMAND(ID_TALKWITH, OnTalk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CIsonPop bZ[W nh

#define MARGIN	7

int CIsonPop::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	CRect rc;
	GetClientRect(&rc);
	rc.DeflateRect(MARGIN, MARGIN);
	if (!m_lbNick.Create(
			WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_BORDER|
			LBS_NOTIFY|LBS_SORT|LBS_NOINTEGRALHEIGHT,
			rc, this, IDC_NICKLIST))
		return -1;

	int i;
	for (i = 0; i < ison.GetSize(); i++) {
		CIsOnEntry& entry = ison.ElementAt(i);
		if (entry.m_fIsOn)
			AddNick(entry.m_sNick);
	}

	ShowWindow(SW_SHOWNA);
	UpdateWindow();

	return 0;
}

void CIsonPop::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);

	if (nType != SIZE_RESTORED || !IsWindow(m_lbNick.m_hWnd))
		return;
	CRect rc(MARGIN, MARGIN, cx - MARGIN, cy - MARGIN);
	m_lbNick.MoveWindow(rc);
}

void CIsonPop::PostNcDestroy() 
{
	m_pWin = 0;
	delete this;
}

void CIsonPop::OnClose() 
{
	DestroyWindow();
}

void CIsonPop::OnWhois() 
{
	int n = m_lbNick.GetCurSel();
	if (n < 0)
		return;
	CString sNick;
	m_lbNick.GetText(n, sNick);
	if (!sNick.IsEmpty())
		CmdWhois(sNick);
}

void CIsonPop::OnTalk() 
{
	int n = m_lbNick.GetCurSel();
	if (n < 0)
		return;
	CString sNick;
	m_lbNick.GetText(n, sNick);
	if (!sNick.IsEmpty())
		CmdTalk(sNick);
}

void CIsonPop::OnDblclkNicklist() 
{
	OnWhois();
}

void CIsonPop::OnSelchangeNicklist() 
{
	int n = m_lbNick.GetCurSel();
	BOOL f = (n >= 0);
}

void CIsonPop::OnDestroy() 
{
	WINDOWPLACEMENT wp;
	if (GetWindowPlacement(&wp)) {
		RECT& rc = wp.rcNormalPosition;
		CString s;
		s.Format(szFmtWindowRect, rc.left, rc.top, rc.right, rc.bottom);
		theApp.WriteProfileString(szSec, szEntry, s);
	}

	CWnd::OnDestroy();
}

void CIsonPop::OnContextMenu(CWnd* pWnd, CPoint pt) 
{
	CMenu menu;
	if (!menu.LoadMenu(IDR_ISON))
		return;
	CMenu* pSubMenu = menu.GetSubMenu(0);
	if (pSubMenu == NULL)
		return;
	pSubMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		pt.x, pt.y, this);
}

UINT CIsonPop::OnNcHitTest(CPoint point) 
{
	if (IsWindow(m_lbNick.m_hWnd)) {
		CRect rcCli;
		GetClientRect(&rcCli);
		CPoint ptCli(point);
		ScreenToClient(&ptCli);
		if (rcCli.PtInRect(ptCli)) {
			CRect rcLB;
			m_lbNick.GetWindowRect(&rcLB);
			if (!rcLB.PtInRect(ptCli))
				return HTCAPTION;
		}
	}
	return CWnd::OnNcHitTest(point);
}

// ison list

CIsOn ison;
UINT g_tmidIsOn = 0;

void CIsOn::Load()
{
	m_sFile = GetDataPathname(IDS_FILE_ISON);
	CStdioFile file;
	if (!file.Open(m_sFile,
			CFile::modeRead | CFile::shareDenyWrite | CFile::typeText))
		return;
	CString sNick;
	CString s;
	TRY {
		while (file.ReadString(s)) {
			LPCTSTR p = s;
			sNick = Token(p);
			if (sNick.IsEmpty())
				continue;
			AddNick(sNick);
		}
	} CATCH(CFileException, e) {
	} END_CATCH
}

void CIsOn::Save()
{
	CStdioFile file;
	if (!file.Open(m_sFile,
			CFile::modeCreate | CFile::modeWrite | CFile::typeText))
		return;
	CIsOnEntry entry;
	CString sBuf;
	int i;
	for (i = 0; i < GetSize(); i++) {
		entry = GetAt(i);
		sBuf = entry.m_sNick;
		if (sBuf.IsEmpty())
			continue;
		sBuf += '\n';
		file.WriteString(sBuf);
	}
}

void CIsOn::Start(UINT nSec)
{
	CWnd* pWnd = AfxGetMainWnd();
	Stop();
	if (nSec < ISON_MIN_INTERVAL)
		nSec = ISON_MIN_INTERVAL;
	m_nMSec = nSec * 1000;
	g_tmidIsOn = pWnd->SetTimer(TMID_ISON, m_nMSec, NULL);
	if (!g_tmidIsOn)
		TRACE(" settimer failed\n");
	pWnd->PostMessage(WM_TIMER, g_tmidIsOn);
}

void CIsOn::Stop()
{
	if (g_tmidIsOn) {
		if (!AfxGetMainWnd()->KillTimer(g_tmidIsOn))
			TRACE(" killtimer failed\n");
		g_tmidIsOn = 0;
	}
	CIsonPop::Show(false);
	int i;
	for (i = 0; i < GetSize(); i++)
		ElementAt(i).m_fIsOn = FALSE;
}

int CIsOn::Find(LPCTSTR pszNick)
{
	int i;
	for (i = 0; i < GetSize(); i++) {
		CIsOnEntry& entry = ElementAt(i);
		if (entry.m_sNick.CompareNoCase(pszNick) == 0)
			return i;
	}
	return -1;
}

void CIsOn::AddNick(LPCTSTR pszNick)
{
	CIsOnEntry entry(pszNick);
	Add(entry);
}

void CIsOn::DelNick(LPCTSTR pszNick)
{
	int i = Find(pszNick);
	if (i >= 0)
		RemoveAt(i);
}

BOOL CIsOn::NickOn(LPCTSTR pszNick)
{
	int i = Find(pszNick);
	if (i < 0)
		return TRUE;
	CIsOnEntry& entry = ElementAt(i);
	time(&entry.m_time);
	entry.m_time += (m_nMSec / 1000 + 10); // time of next check + lag
	if (entry.m_fIsOn)
		return FALSE;
	entry.m_fIsOn = TRUE;
	return TRUE;
}

void CIsOn::Expire()
{
	int i;
	for (i = 0; i < GetSize(); i++) {
		CIsOnEntry& entry = ElementAt(i);
		if (entry.m_fIsOn) {
			time_t tmCur;
			time(&tmCur);
			if (tmCur >= entry.m_time) {
				entry.m_fIsOn = FALSE;
				CIsonPop::Nick(entry.m_sNick, FALSE);
			}
		}
	}
}

#if 0 // delete Apr 21 1998
// ------------------
// DlgAway _CAO

DlgAway* DlgAway::s_pDlgAway = 0;
HWND DlgAway::s_hwndActive = 0;

void DlgAway::Activate(BOOL fActive)
{
	if (fActive) {
		if (s_pDlgAway)
			return;
		new DlgAway(CWnd::GetDesktopWindow());
	} else if (s_pDlgAway)
		s_pDlgAway->DestroyWindow();
}

DlgAway::DlgAway(CWnd* pParent /*=NULL*/)
	: CDialog(DlgAway::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgAway)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
	s_pDlgAway = this;
	s_hwndActive = ::GetActiveWindow();
	Create(IDD, pParent);
	if (IsWindow(s_hwndActive))
		::SetActiveWindow(s_hwndActive);
}

void DlgAway::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgAway)
                //  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(DlgAway, CDialog)
	//{{AFX_MSG_MAP(DlgAway)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// DlgAway bZ[W nh

static char szAwayEntry[] = _T("Away");
static char szFmtWindowPos[] = "%d,%d";

BOOL DlgAway::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CString s = theApp.GetProfileString(szSec, szAwayEntry);
	int x;
	int y;
	if (!s.IsEmpty() && sscanf(s, szFmtWindowPos, &x, &y) == 2) {
		CRect rcDesk;
		CWnd::GetDesktopWindow()->GetWindowRect(&rcDesk);
		CRect rc;
		GetWindowRect(&rc);
		rc.OffsetRect(x - rc.left, y - rc.top);
		if (rc.right > rcDesk.right)
			rc.OffsetRect(rcDesk.right - rc.right, 0);
		if (rc.bottom > rcDesk.bottom)
			rc.OffsetRect(0, rcDesk.bottom - rc.bottom);
		MoveWindow(&rc);
	} else
		CenterWindow();
	SetWindowPos(&wndTopMost, 0, 0, 0, 0,
		SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOSIZE|SWP_SHOWWINDOW);
	if (!g_opt.sNickAway.IsEmpty()) {
		m_sOldNick = g_con.m_sNick;
		CmdNick(g_opt.sNickAway);
	}
	return TRUE;
}

void DlgAway::OnOK() 
{
	OnCancel();
}

void DlgAway::OnCancel() 
{
	Cmd("AWAY");
}

void DlgAway::PostNcDestroy() 
{
	if (!m_sOldNick.IsEmpty())
		CmdNick(m_sOldNick);
	s_pDlgAway = 0;
	delete this;
}

void DlgAway::OnDestroy() 
{
	WINDOWPLACEMENT wp;
	if (GetWindowPlacement(&wp)) {
		RECT& rc = wp.rcNormalPosition;
		CString s;
		s.Format(szFmtWindowPos, rc.left, rc.top);
		theApp.WriteProfileString(szSec, szAwayEntry, s);
	}

	CDialog::OnDestroy();
}
#endif

//
// DlgAwaySet _CAO
//

DlgAwaySet::DlgAwaySet(CWnd* pParent /*=NULL*/)
	: CDialog(DlgAwaySet::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgAwaySet)
	m_sMsg = _T(g_con.m_sLastAway.IsEmpty() ? "Away.." : g_con.m_sLastAway);
	//}}AFX_DATA_INIT
}

void DlgAwaySet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgAwaySet)
	DDX_Text(pDX, IDC_AWAYSET_MSG, m_sMsg);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(DlgAwaySet, CDialog)
	//{{AFX_MSG_MAP(DlgAwaySet)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// DlgAwaySet bZ[W nh

//
// DlgTopic _CAO
//

DlgTopic::DlgTopic(FrameChan* pFrame)
	: CDialog(DlgTopic::IDD, pFrame)
{
	//{{AFX_DATA_INIT(DlgTopic)
	m_sTopic = _T("");
	m_fKeep = FALSE;
	//}}AFX_DATA_INIT

	m_pFrame = pFrame;
	if (!pFrame->m_sTopicKeep.IsEmpty()) {
		m_sTopic = pFrame->m_sTopicKeep;
		m_fKeep = TRUE;
	} else
		m_sTopic = pFrame->m_sTopic;

	if (Create(DlgTopic::IDD, pFrame))
		pFrame->m_pDlgTopic = this;
}

void DlgTopic::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgTopic)
	DDX_Text(pDX, IDC_TOPIC, m_sTopic);
	DDX_Check(pDX, IDC_TOPIC_KEEP, m_fKeep);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(DlgTopic, CDialog)
	//{{AFX_MSG_MAP(DlgTopic)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// DlgTopic bZ[W nh

BOOL DlgTopic::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText(m_pFrame->m_sTarget);

	return TRUE;
}

void DlgTopic::OnCancel() 
{
	if (UpdateData(TRUE) && !m_fKeep)
		m_pFrame->TopicChange(m_sTopic, m_fKeep, FALSE);

	DestroyWindow();
}

void DlgTopic::PostNcDestroy() 
{
	m_pFrame->m_pDlgTopic = 0;
	delete this;
}

void DlgTopic::OnOK() 
{
	if (!UpdateData(TRUE))
		return;

	m_pFrame->TopicChange(m_sTopic, m_fKeep);

	DestroyWindow();
}

// DlgMe _CAO

DlgMe::DlgMe(CWnd* pParent /*=NULL*/)
	: CDialog(DlgMe::IDD, pParent)
{
	//{{AFX_DATA_INIT(DlgMe)
	m_sMe = _T("");
	//}}AFX_DATA_INIT
}

void DlgMe::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DlgMe)
	DDX_Text(pDX, IDC_ME, m_sMe);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DlgMe, CDialog)
	//{{AFX_MSG_MAP(DlgMe)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// DlgMe bZ[W nh
