// DlgRcv.cpp : implementation file

#include "stdafx.h"
#include "mchat.h"
#include "dlgdcc.h"
#include "dlgrcv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CDlgRcv dialog

static TCHAR BASED_CODE szDCC[] = _T("DCC");
static TCHAR BASED_CODE szDirectory[] = _T("Directory");
static TCHAR BASED_CODE szAutoReceive[] = _T("AutoReceive");

void CDlgRcv::Timer(bool f)
{
	if (f) {
		m_nCountdown = 5;
		m_nTMIDSec = SetTimer(TMID_DCCRCV, 1000, 0); //1sec
		ShowTimer(true);
	} else if (m_nTMIDSec) {
		KillTimer(m_nTMIDSec);
		m_nTMIDSec = 0;
		ShowTimer(false);
	}
}

void CDlgRcv::ShowTimer(bool f)
{
	if (!f) {
		m_stCountdown.ShowWindow(SW_HIDE);
		return;
	}
	CString s;
	s.Format("%d", m_nCountdown);
	m_stCountdown.SetWindowText(s);
	m_stCountdown.ShowWindow(SW_SHOW);
}

CDlgRcv::CDlgRcv(LPCTSTR pNick, LPCTSTR pFile, u_long ulSize,
				 u_long ulHost, u_short usPort,
				 CWnd* pParent /*=NULL*/)
	: CDialog(CDlgRcv::IDD, pParent)
{
	char buf[20];
	ltoa(ulSize, buf, 10);
	//{{AFX_DATA_INIT(CDlgRcv)
	m_sNick = pNick;
	m_sFileSize = buf;
	m_sFileName = _T("");
	m_sSaveAs = _T("");
	//}}AFX_DATA_INIT
	m_sAddress.Format("%d.%d.%d.%d:%d",
		ulHost >> 24, (ulHost >> 16) & 0xff,
		(ulHost >> 8) & 0xff, (ulHost & 0xff), usPort);
	m_ulSize = ulSize;
	m_ulHost = ulHost;
	m_usPort = usPort;

	m_sFileName = UnescapeString(ExtractFileName(pFile));
	m_sSaveAs = AfxGetApp()->GetProfileString(szDCC, szDirectory);
	DirExtend(m_sSaveAs, m_sFileName);
	m_fAutoReceive = AfxGetApp()->GetProfileInt(szDCC, szAutoReceive, 0) != 0;

	Create(CDlgRcv::IDD, GetDesktopWindow());
}


void CDlgRcv::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgRcv)
	DDX_Control(pDX, IDC_COUNTDOWN, m_stCountdown);
	DDX_Control(pDX, IDC_DCC_AUTO_RECEIVE, m_btAutoReceive);
	DDX_Text(pDX, IDC_NICK, m_sNick);
	DDX_Text(pDX, IDC_FILESIZE, m_sFileSize);
	DDX_Text(pDX, IDC_FILENAME, m_sFileName);
	DDX_Text(pDX, IDC_SAVEAS, m_sSaveAs);
	DDX_Text(pDX, IDC_ADDRESS, m_sAddress);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgRcv, CDialog)
	//{{AFX_MSG_MAP(CDlgRcv)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_DCC_AUTO_RECEIVE, OnDccAutoReceive)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CDlgRcv message handlers

static char BASED_CODE szFilter[] = "All Files(*.*)|*.*||";

void CDlgRcv::OnBrowse() 
{
	UpdateData(TRUE);
	CFileDialog dlg(FALSE, NULL, m_sSaveAs,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		szFilter, this);
	if (dlg.DoModal() != IDOK)
		return;
	m_sSaveAs = dlg.GetPathName();
	UpdateData(FALSE);
}

void CDlgRcv::OnCancel() 
{
	DestroyWindow();
}

void CDlgRcv::OnOK() 
{
	Timer(false);

	UpdateData(TRUE);
	if (m_sSaveAs.IsEmpty())
		return;

	CString sDir(ExtractDirName(m_sSaveAs));
	AfxGetApp()->WriteProfileString(szDCC, szDirectory, sDir);
	AfxGetApp()->WriteProfileInt(szDCC, szAutoReceive, m_fAutoReceive);

	CDlgDcc* pDcc = new CDlgDcc(CDlgDcc::TypeRcv);
	if (pDcc->OpenFile(m_sSaveAs, m_ulSize))
		pDcc->DoConnect(m_ulHost, m_usPort);

	DestroyWindow();
}

void CDlgRcv::PostNcDestroy() 
{
	delete this;
}

BOOL CDlgRcv::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_btAutoReceive.SetCheck(m_fAutoReceive);

	if (m_fAutoReceive)
		Timer(true);

	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgRcv::OnDccAutoReceive() 
{
	Timer(false);

	m_fAutoReceive = !m_fAutoReceive;
	m_btAutoReceive.SetCheck(m_fAutoReceive);

	if (m_fAutoReceive)
		Timer(true);
}

void CDlgRcv::OnTimer(UINT nIDEvent) 
{
	if (m_nTMIDSec && m_nTMIDSec == nIDEvent) {
		m_nCountdown--;
		ShowTimer(true);
		if (m_nCountdown <= 0) {
			Timer(false);
			PostMessage(WM_COMMAND, IDOK);
			return;
		}
	}

	CDialog::OnTimer(nIDEvent);
}

void CDlgRcv::OnDestroy() 
{
	Timer(false);

	CDialog::OnDestroy();
}
