#include "stdafx.h"
#include "mchat.h"
#include "text.h"
#include "nicklist.h"
#include "dlgban.h"
#include "dlgchsw.h"
#include "dlgmisc.h"
#include "input.h"
#include "dlginvite.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char szMode[] = "MODE";
char szTopic[] = "TOPIC";

// splitter

IMPLEMENT_DYNCREATE(CSplit, CSplitterWnd)

BEGIN_MESSAGE_MAP(CSplit, CSplitterWnd)
	//{{AFX_MSG_MAP(CSplit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CSplit::StopTracking(BOOL bAccept)
{
	CSplitterWnd::StopTracking(bAccept);
	if (!bAccept)
		return;
	((CFrame*)GetParentFrame())->InputSetFocus();
}

// channel frame

BEGIN_MESSAGE_MAP(FrameChan, CFrame)
	//{{AFX_MSG_MAP(FrameChan)
	ON_WM_CLOSE()
	ON_COMMAND(ID_PART, OnPart)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_NAMES_WHOIS, OnNamesWhois)
	ON_COMMAND(ID_NAMES_TALK, OnNamesTalk)
	ON_COMMAND(ID_NAMES_IGNORE, OnNamesIgnore)
	ON_COMMAND(ID_NAMES_OP_KICK, OnNamesOpKick)
	ON_COMMAND(ID_NAMES_OP_GIVEOP, OnNamesOpGiveop)
	ON_COMMAND(ID_NAMES_OP_STRIPOP, OnNamesOpStripop)
	ON_COMMAND(ID_NAMES_OP_AUTOOP, OnNamesOpAutoop)
	ON_COMMAND(ID_NAMES_OP_BAN, OnNamesOpBan)
	ON_UPDATE_COMMAND_UI(ID_NAMES_OP_KICK, OnUpdateNamesOp)
	ON_UPDATE_COMMAND_UI(ID_NAMES_WHOIS, OnUpdateNamesHasSel)
	ON_COMMAND(ID_NAMES_PING, OnNamesPing)
	ON_COMMAND(ID_NAMES_TIME, OnNamesTime)
	ON_COMMAND(ID_NAMES_USERINFO, OnNamesUserinfo)
	ON_COMMAND(ID_NAMES_FINGER, OnNamesFinger)
	ON_COMMAND(ID_NAMES_VERSION, OnNamesVersion)
	ON_COMMAND(ID_NAMES_CLIENTINFO, OnNamesClientinfo)
	ON_COMMAND(ID_NAMES_HELP, OnNamesHelp)
	ON_COMMAND(ID_NAMES_DCC_CHAT, OnNamesDccChat)
	ON_COMMAND(ID_NAMES_DCC_SEND, OnNamesDccSend)
	ON_UPDATE_COMMAND_UI(ID_NAMES_IGNORE, OnUpdateNamesOnlyOne)
	ON_COMMAND(ID_NAMES_REFRESH, OnNamesRefresh)
	ON_COMMAND(ID_CHAN_MODE, OnChanMode)
	ON_COMMAND(ID_CHAN_BAN, OnChanBan)
	ON_COMMAND(ID_WINDOW_SPLIT, OnViewSplit)
	ON_WM_DESTROY()
	ON_WM_CREATE()
	ON_COMMAND(ID_TOPIC, OnTopic)
	ON_COMMAND(ID_OPLIST, OnOplist)
	ON_COMMAND(ID_INVITE, OnInvite)
	ON_COMMAND(ID_CHAN_EXCEPTION, OnChanException)
	ON_COMMAND(ID_CHAN_INVITE, OnChanInvite)
	ON_UPDATE_COMMAND_UI(ID_NAMES_OP_GIVEOP, OnUpdateNamesOp)
	ON_UPDATE_COMMAND_UI(ID_NAMES_OP_STRIPOP, OnUpdateNamesOp)
	ON_UPDATE_COMMAND_UI(ID_NAMES_OP_BAN, OnUpdateNamesOp)
	ON_UPDATE_COMMAND_UI(ID_NAMES_TALK, OnUpdateNamesHasSel)
	ON_UPDATE_COMMAND_UI(ID_NAMES_PING, OnUpdateNamesHasSel)
	ON_UPDATE_COMMAND_UI(ID_NAMES_VERSION, OnUpdateNamesHasSel)
	ON_UPDATE_COMMAND_UI(ID_NAMES_USERINFO, OnUpdateNamesHasSel)
	ON_UPDATE_COMMAND_UI(ID_NAMES_FINGER, OnUpdateNamesHasSel)
	ON_UPDATE_COMMAND_UI(ID_NAMES_CLIENTINFO, OnUpdateNamesHasSel)
	ON_UPDATE_COMMAND_UI(ID_NAMES_TIME, OnUpdateNamesHasSel)
	ON_UPDATE_COMMAND_UI(ID_NAMES_DCC_CHAT, OnUpdateNamesOnlyOne)
	ON_UPDATE_COMMAND_UI(ID_NAMES_DCC_SEND, OnUpdateNamesOnlyOne)
	ON_UPDATE_COMMAND_UI(ID_NAMES_OP_AUTOOP, OnUpdateNamesOnlyOne)
	ON_COMMAND(ID_NAMES_DNSLOOKUP, OnNamesDnslookup)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WMU_NICKLIST_RECREATE, OnNicklistRecreate)
	ON_MESSAGE(WMU_DEFER_CHANMODE, OnDeferChanMode)
	ON_MESSAGE(WMU_SOCK_DNSLOOKUP, OnSockDnslookup)
END_MESSAGE_MAP()

FrameChan::FrameChan(LPCTSTR pszTarget)
	: CFrame(TypeChan, IDR_CHAN, "Chan", pszTarget)
{
	m_pNicks = 0;
	m_pDlgChanSwitch = 0;
	m_pDlgBanList = m_pDlgExceptionList = m_pDlgInviteList = 0;
	m_pDlgTopic = 0;
	m_fChanJoin = FALSE;
	m_pModeKeep = 0;
	m_hAsyncDnslookup = 0;

	ModeClear();

	Chan* pChan;
	if (g_mapChan.Lookup(pszTarget, pChan)) {
		if (pChan->m_pMode)
			m_pModeKeep = new ChanMode(*pChan->m_pMode);
		if (!pChan->m_sTopic.IsEmpty())
			m_sTopicKeep = pChan->m_sTopic;
		if (!pChan->m_lsOpPlus.IsEmpty())
			m_lsOpPlus.Copy(pChan->m_lsOpPlus);
	}

	LoadFrame(IDR_CHAN, WS_OVERLAPPEDWINDOW);

	ShowWindow(SW_SHOW);
	UpdateWindow();
}

FrameChan::~FrameChan()
{
	if (m_pNicks)
		delete m_pNicks;

	if (m_pModeKeep)
		delete m_pModeKeep;
}

static struct RowCol {
	int nRows;
	int nCols;
	int nRowText;
	int nColText;
	int nRowNicks;
	int nColNicks;
} arRowCol[] = {
	{ 2, 1, 1, 0, 0, 0 },	// top
	{ 1, 2, 0, 1, 0, 0 },	// left
	{ 1, 2, 0, 0, 0, 1 },	// right
	{ 2, 1, 0, 0, 1, 0 },	// bottom
};

#define DEF_SPLIT_ROW	60
#define DEF_SPLIT_COL	80

int FrameChan::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	int nPos = g_opt.nNLPos;
	if (nPos < 0 || nPos >= sizeof arRowCol / sizeof arRowCol[0])
		nPos = NLPOS_RIGHT;
	RowCol& info = arRowCol[nPos];

	if (!m_split.CreateStatic(this, info.nRows, info.nCols,
		WS_CHILD | WS_VISIBLE | WS_BORDER))
		return -1;

	m_split.CreateView(info.nRowText, info.nColText,
		RUNTIME_CLASS(CText), m_sizeText,
		(CCreateContext*)lpCreateStruct->lpCreateParams);
	m_pText = (CText*)m_split.GetPane(info.nRowText, info.nColText);

	m_split.CreateView(info.nRowNicks, info.nColNicks,
		RUNTIME_CLASS(CNickWnd), m_sizeNicks,
		(CCreateContext*)lpCreateStruct->lpCreateParams);
	m_pNicks = (CNickWnd*)m_split.GetPane(info.nRowNicks, info.nColNicks);
	m_pNicks->FontChange();

	if (CFrame::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_sizeText.cx || !m_sizeText.cy || !m_sizeNicks.cx || !m_sizeNicks.cy) {
		CRect rc;
		m_split.GetClientRect(&rc);
		if (info.nRows > 1) {
			int n = rc.Height() *
				(info.nRowText == 0 ?
					DEF_SPLIT_ROW : (100 - DEF_SPLIT_ROW)) / 100;
			m_split.SetRowInfo(0, n, 0);
		} else {
			int n = rc.Width() *
				(info.nColText == 0 ?
					DEF_SPLIT_COL : (100 - DEF_SPLIT_COL)) / 100;
			m_split.SetColumnInfo(0, n, 0);
		}
		m_split.RecalcLayout();
	}
	
	return 0;
}

void FrameChan::FontChange()
{
	if (m_pNicks)
		m_pNicks->ReCreate();
	CFrame::FontChange();
}

void FrameChan::ModeClear()
{
	m_mode.Clear();
	m_fOpMe = FALSE;
	m_sTopic.Empty();
}

void FrameChan::ModeChange(const ChanMode* pMode, BOOL fKeep)
{
	m_mode.Apply(m_sTarget, *pMode);
	if (fKeep) {
		if (m_pModeKeep)
			*m_pModeKeep = *pMode;
		else
			m_pModeKeep = new ChanMode(*pMode);
	} else {
		if (m_pModeKeep) {
			delete m_pModeKeep;
			m_pModeKeep = 0;
		}
	}
	g_mapChan.SetMode(m_sTarget, m_pModeKeep);
}

void FrameChan::ModeAutoOP()
{
	if (m_fOpMe && m_pNicks)
		m_pNicks->m_list.ModeAutoOP();
}

void FrameChan::TopicChange(LPCTSTR pszTopic, BOOL fKeep, BOOL fSet)
{
	if (fSet)
		CmdTrail(szTopic, m_sTarget, pszTopic);

	LPCTSTR p = 0;
	if (fKeep) {
		m_sTopicKeep = pszTopic;
		if (*pszTopic)
			p = pszTopic;
	} else
		m_sTopicKeep.Empty();

	g_mapChan.SetTopic(m_sTarget, p);
}

void FrameChan::TopicKeep()
{
	if (!m_sTopicKeep.IsEmpty() && m_sTopicKeep != m_sTopic)
		CmdTrail(szTopic, m_sTarget, m_sTopicKeep);
}

// command override

void FrameChan::CmdTopic(LPCTSTR pStr)
{
	if (*pStr == 0)
		Cmd("TOPIC", m_sTarget);
	else {
		if (!m_sTopicKeep.IsEmpty())
			m_sTopicKeep = pStr;
		CmdTrail("TOPIC", m_sTarget, pStr);
	}
}

BOOL FrameChan::SendData(LPCTSTR pStr)
{
	if (!m_fChanJoin)
		return FALSE;
	CmdTrail("PRIVMSG", m_sTarget, pStr);
	LineText(g_con.m_sNick, pStr);
	return TRUE;
}

void FrameChan::KeyTab()
{
	if (IsKeyCtrl()) {
		CFrame::KeyTab();
		return;
	}
	if (m_pInput->m_fFocus) {
		if (m_pNicks)
			m_pNicks->m_list.SetFocus();
	} else
		m_pInput->SetFocus();
}

// overrides

BOOL FrameChan::HasNick(LPCTSTR pNick)
{
	return m_pNicks && m_pNicks->m_list.Exists(pNick);
}

static CString ExcludeCtrlChar(LPCTSTR pStr)
{
	CString s;
	LPTSTR pBuf = s.GetBuffer(lstrlen(pStr));
	LPTSTR p = pBuf;
	TCHAR c;
	while ((c = *pStr++) != 0) {
		if (_ismbblead(c)) {
			if (*pStr) {
				*p++ = c;
				*p++ = *pStr++;
				continue;
			}
			continue;
		}
		if (iscntrl(c))
			continue;
		*p++ = c;
	}
	*p = 0;
	s.ReleaseBuffer(p - pBuf);
	return s;
}

CString FrameChan::GetTopic()
{
	CString s(ExcludeCtrlChar(m_sTopic));
	return s;
}

void FrameChan::MsgTopic(const Packet& pac)
{
	CString s;
	s.Format("*%s Topic: %s", pac.sNick, pac.sTrail);
	if (g_opt.fMsgTopic)
		LineNotice(NULL, s);
	else
		ShowStatus(s);
	m_sTopic = pac.sTrail;
	MakeTitle();

	if (pac.sNick.CompareNoCase(g_con.m_sNick) == 0 && !m_sTopicKeep.IsEmpty()) {
		m_sTopicKeep = pac.sTrail;
		g_mapChan.SetTopic(m_sTarget, pac.sTrail);
	} else
		TopicKeep();
}

void FrameChan::MsgJoin(const Packet& pac, LPCTSTR pChan, LPCTSTR pMode)
{
	BOOL fMe = FALSE;
	if (m_pNicks) {
		m_pNicks->m_list.Add(pac.sNick, pac.sAddr);
		if (!m_fChanJoin && pac.sNick.CompareNoCase(g_con.m_sNick) == 0) {
			fMe = TRUE;	// join myself
			NamesRedraw(FALSE);
			ClearNames();
			ModeClear();
			m_fChanJoin = TRUE;
			Cmd("WHO", pChan);
			Cmd(szMode, pChan);
		}
	}

	BOOL fModeOP = FALSE;
	if (pMode) {
		LPCTSTR p = pMode;
		TCHAR c;
		while ((c = *p++) != 0) {
			switch (c) {
			case 'o':
				RplModeOP(TRUE, pac.sNick);
				fModeOP = TRUE;
				break;
			case 'v':
				break;
			default:
				TRACE("join mode combine: %c\n", c);
			}
		}
	}

	// if i join and not op mode conbine,
	// it's possible be an old type server.
	//if (fMe && pMode == NULL && !m_sTopicKeep.IsEmpty())
	//	Cmd(szTopic, pChan);

	if (m_fOpMe && !fModeOP && m_lsOpPlus.IsMatch(pac.sPrefix))
		if (!DeferPostMessage(this, WMU_DEFER_CHANMODE))
			Cmd(szMode, m_sTarget, "+o", pac.sNick);

	CString s;
	s.Format("join (%s)", pac.sPrefix);

	if (pMode) {
		CString ss;
		ss.Format(" +%s", pMode);
		s += ss;
	}
	LineNotice(pac.sNick, s, g_opt.fMsgJoin);
}

void FrameChan::MsgPart(const Packet& pac, LPCTSTR pChan)
{
	if (m_pNicks)
		m_pNicks->m_list.Del(pac.sNick);
	CString s;
	s.Format("part (%s) %s", pac.sAddr, pac.sTrail);
	LineNotice(pac.sNick, s, g_opt.fMsgPart);
	if (g_con.m_sNick.CompareNoCase(pac.sNick) == 0) {
		m_fChanJoin = FALSE;
		PostMessage(WM_CLOSE);
	}
}

void FrameChan::MsgKick(LPCTSTR pNick, LPCTSTR pChan, LPCTSTR pParm, LPCTSTR pTrail)
{
	CString sTarget(Token(pParm));

	CString s;
	s.Format("kick %s (%s)", (LPCTSTR)sTarget, pTrail);
	LineNotice(pNick, s, g_opt.fMsgKick);

	if (m_pNicks)
		m_pNicks->m_list.Del(sTarget);

	if (sTarget.CompareNoCase(g_con.m_sNick) == 0) {
		optBeep.Play(BEEP_Kicked);
		s.Format(IDS_FMT_BE_KICKED, pNick);
		LineError(s);
		if (m_pNicks)
			m_pNicks->m_list.Reset();
		if (g_opt.fRejoin)
			CmdJoin(pChan);
		m_fChanJoin = FALSE;
	}
}

void FrameChan::MsgNick(LPCTSTR pNick, LPCTSTR pNickTo)
{
	m_pNicks->m_list.Rename(pNick, pNickTo);
	CFrame::MsgNick(pNick, pNickTo);
}

void FrameChan::MsgQuit(LPCTSTR pNick, LPCTSTR pTrail)
{
	m_pNicks->m_list.Del(pNick);
	CFrame::MsgQuit(pNick, pTrail);
}

void FrameChan::MsgMode(const Packet& pac, LPCTSTR pChan, LPCTSTR pParm)
{
	CString s;
	s.Format("*%s mode %s", pac.sNick, pParm);
	LineStat(s, g_opt.fMsgMode);
	RplChanMode(pac, pChan, pParm);
}

void FrameChan::MsgDisconnect()
{
	if (m_fChanJoin) {
		m_fChanJoin = FALSE;
		ClearNames();
		CFrame::MsgDisconnect();
	}
}

// reply handling

void FrameChan::RplBanList(LPCTSTR pChan, LPCTSTR pBan)
{
	if (m_pDlgBanList)
		m_pDlgBanList->Append(pBan);
	else
		CFrame::RplBanList(pChan, pBan);
}

void FrameChan::RplExceptionList(LPCTSTR pChan, LPCTSTR pBan)
{
	if (m_pDlgExceptionList)
		m_pDlgExceptionList->Append(pBan);
	else
		CFrame::RplExceptionList(pChan, pBan);
}

void FrameChan::RplInviteList(LPCTSTR pChan, LPCTSTR pBan)
{
	if (m_pDlgInviteList)
		m_pDlgInviteList->Append(pBan);
	else
		CFrame::RplInviteList(pChan, pBan);
}

void FrameChan::RplWho(LPCTSTR pChan, const CUser& user)
{
	if (!m_pNicks)
		return;
	if (g_con.m_sNick.CompareNoCase(user.m_sNick) == 0) {
		if (user.m_fOp != m_fOpMe) {
			m_fOpMe = user.m_fOp;
			MakeTitle();
		}
	}
	m_pNicks->m_list.Modify(user);
}

void FrameChan::RplWhoEnd()
{
	if (m_pNicks)
		m_pNicks->m_list.Redraw(TRUE);
}

void FrameChan::RplNoTopic(LPCTSTR pChan)
{
	if (!m_sTopic.IsEmpty()) {
		m_sTopic.Empty();
		MakeTitle();
	}
	if (m_fOpMe && !m_sTopicKeep.IsEmpty())
		CmdTrail(szTopic, m_sTarget, m_sTopicKeep);
}

void FrameChan::RplTopic(LPCTSTR pChan, LPCTSTR pTopic)
{
	m_sTopic = pTopic;
	MakeTitle();
	CString s;
	s.Format("*Topic %s: %s", pChan, pTopic);
	LineNotice(NULL, s);

	TopicKeep();
}

void FrameChan::RplChanMode(const Packet& pac, LPCTSTR pChan, LPCTSTR p)
{
	m_mode.FromString(p, this);

	if (m_fOpMe && pac.sNick.CompareNoCase(g_con.m_sNick) != 0) {
		if (m_pModeKeep)
			m_mode.Apply(m_sTarget, *m_pModeKeep);
	}
	MakeTitle();
}

void FrameChan::RplModeOP(BOOL fPlus, LPCTSTR pParm)
{
	m_pNicks->m_list.ModeOP(pParm, fPlus);
	if (g_con.m_sNick.CompareNoCase(pParm) == 0) {
		m_fOpMe = fPlus;
		MakeTitle();
		TopicKeep();
	}
	if (m_fOpMe && !DeferPostMessage(this, WMU_DEFER_CHANMODE))
		ModeAutoOP();
}

void FrameChan::RplModeBan(BOOL fPlus, LPCTSTR pParm)
{
	if (m_pDlgBanList) {
		if (fPlus)
			m_pDlgBanList->Append(pParm);
		else
			m_pDlgBanList->Delete(pParm);
	}
}

void FrameChan::RplModeException(BOOL fPlus, LPCTSTR pParm)
{
	if (m_pDlgExceptionList) {
		if (fPlus)
			m_pDlgExceptionList->Append(pParm);
		else
			m_pDlgExceptionList->Delete(pParm);
	}
}

void FrameChan::RplModeInvite(BOOL fPlus, LPCTSTR pParm)
{
	if (m_pDlgInviteList) {
		if (fPlus)
			m_pDlgInviteList->Append(pParm);
		else
			m_pDlgInviteList->Delete(pParm);
	}
}

void FrameChan::OnClose() 
{
	g_con.m_sChannelDefault = m_sTarget;
	if (m_fChanJoin)
		CmdPart(m_sTarget);
	CFrame::OnClose();
}

void FrameChan::OnPart() 
{
	CmdPart(m_sTarget);
}

void FrameChan::MenuOnNames(const CPoint pt)
{
	CMenu menu;
	if (!menu.LoadMenu(IDR_NAMES))
		return;
	CMenu* pSubMenu = menu.GetSubMenu(0);
	if (pSubMenu == NULL)
		return;
	pSubMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
		pt.x, pt.y, this);
}

void FrameChan::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	if (m_pNicks) {
		CRect rc;
		m_pNicks->m_list.GetWindowRect(&rc);
		if (rc.PtInRect(point)) {
			MenuOnNames(point);
			return;
		}
	}
	CFrame::OnContextMenu(pWnd, point);
}

void FrameChan::OnNamesWhois() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdWhois(arNames[i]);
}

void FrameChan::OnNamesTalk() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdTalk(arNames[i]);
}

void FrameChan::OnNamesIgnore() 
{
	CString sNick, sAddr;
	if (!m_pNicks->m_list.GetSelNickAddr(sNick, sAddr))
		return;
	CString s;
	if (sAddr.IsEmpty())
		s.Format("%s!*", sNick);
	else
		s.Format("*!%s", sAddr);
	IgnorePopup(this, s);
}

void FrameChan::OnNamesOpKick() 
{
	m_pNicks->m_list.Kick();
}

void FrameChan::OnUpdateNamesOp(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pNicks->m_list.GetSelectedCount() > 0);
}

void FrameChan::OnNamesOpBan() 
{
	m_pNicks->m_list.KickBan();
}

void FrameChan::OnUpdateNamesHasSel(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pNicks->m_list.GetSelectedCount() > 0);
}

void FrameChan::OpHelper(char chPlus)
{
	CString sOpt = chPlus;
	CString sNames;
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int nAppend;
	int i;
	for (i = nAppend = 0; i < n; i++) {
		sOpt += 'o';
		if (nAppend)
			sNames += ' ';
		sNames += arNames[i];
		if (++nAppend >= 3) {
			CmdU(szMode, m_sTarget, sOpt, sNames);
			sOpt = chPlus;
			sNames.Empty();
			nAppend = 0;
		}
	}
	if (nAppend)
		CmdU(szMode, m_sTarget, sOpt, sNames);
}

void FrameChan::OnNamesOpGiveop() 
{
	OpHelper('+');
}

void FrameChan::OnNamesOpStripop() 
{
	OpHelper('-');
}

void FrameChan::OnNamesOpAutoop() 
{
	CString sPrefix;
	if (!m_pNicks->m_list.GetSelPrefix(sPrefix))
		return;
	DlgOPList dlg(this, sPrefix);
	dlg.DoModal();
}

void FrameChan::OnNamesPing() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdCtcpPing(arNames[i]);
}

void FrameChan::OnNamesTime() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdCtcpTime(arNames[i]);
}

void FrameChan::OnNamesUserinfo() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdCtcpUserinfo(arNames[i]);
}

void FrameChan::OnNamesFinger() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdCtcpFinger(arNames[i]);
}

void FrameChan::OnNamesVersion() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdCtcpVersion(arNames[i]);
}

void FrameChan::OnNamesClientinfo() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	int i;
	for (i = 0; i < n; i++)
		CmdCtcpClientinfo(arNames[i]);
}

void FrameChan::OnNamesHelp() 
{
	theApp.WinHelp(0x50000UL + IDW_NAMES, HELP_CONTEXT);
}

void FrameChan::OnNamesDccChat() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	if (n != 1)
		return;
	CmdDccChat(arNames[0]);
}

void FrameChan::OnNamesDccSend() 
{
	int n = m_pNicks->m_list.GetSelectedNames(arNames);
	if (n == 1)
		CmdDccSend(arNames[0]);
}

void FrameChan::OnUpdateNamesOnlyOne(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_pNicks->m_list.GetSelectedCount() == 1);
}

void FrameChan::OnNamesDnslookup() 
{
	CString sNick, sAddr;
	if (!m_pNicks->m_list.GetSelNickAddr(sNick, sAddr))
		return;

	LPCTSTR pAddr = sAddr;
	int n = sAddr.Find('@', 0);
	if (n >= 0)
		pAddr += (n + 1);

	CString s;
	s.Format("Lookup %s (%s)", (LPCTSTR)sNick, pAddr);
	LineStat(s);

	m_hAsyncDnslookup = WSAAsyncGetHostByName(
		m_hWnd,
		WMU_SOCK_DNSLOOKUP, pAddr,
		m_bufHostEntDnslookup, sizeof (m_bufHostEntDnslookup));
	if (!m_hAsyncDnslookup) {
		int err = WSAGetLastError();
		TRACE("WSAAsyncGetHostByName() return %d\n", err);
		CString s;
		s.Format("Cannot lookup address: code=%d", err);
		LineError(s);
		return;
	}
}

LONG FrameChan::OnSockDnslookup(UINT wParam, LONG lParam)
{
	HANDLE hHandle = (HANDLE)wParam;
	if (hHandle != m_hAsyncDnslookup) {
		TRACE("asyncreq handle mismatch %d, %d\n", hHandle, m_hAsyncDnslookup);
	}
	m_hAsyncDnslookup = 0;

	WORD wErr = WSAGETASYNCERROR(lParam);
	if (wErr) {
		CString s;
		s.Format("Cannot resolve local host: code=%d", wErr);
		LineError(s);
		return 0;
	}

	HOSTENT* pEnt = (HOSTENT*)m_bufHostEntDnslookup;
	struct in_addr in;
	in.s_addr = *(unsigned long*)pEnt->h_addr_list[0];

	CString s;
	s.Format("%s = %s", pEnt->h_name, inet_ntoa(in));
	LineStat(s);

	return 0;
}

void FrameChan::ClearNames()
{
	if (m_pNicks)
		m_pNicks->m_list.Reset();
}

void FrameChan::NamesRedraw(BOOL fOn)
{
	if (m_pNicks)
		m_pNicks->m_list.Redraw(fOn);
}

void FrameChan::OnNamesRefresh() 
{
	if (m_pNicks) {
		NamesRedraw(FALSE);
		ClearNames();
		CmdWho(m_sTarget);
	}
}

void FrameChan::OnChanMode() 
{
	if (m_pDlgChanSwitch) {
		m_pDlgChanSwitch->SetForegroundWindow();
		return;
	}
	new CDlgChanSwitch(this);
}

void FrameChan::OnChanBan() 
{
	if (m_pDlgBanList) {
		m_pDlgBanList->SetForegroundWindow();
		return;
	}
	new CDlgBan(this, &m_pDlgBanList, IDS_BAN_LIST, 'b');
	Cmd(szMode, m_sTarget, "+b");
}

void FrameChan::OnChanException() 
{
	if (m_pDlgExceptionList) {
		m_pDlgExceptionList->SetForegroundWindow();
		return;
	}
	new CDlgBan(this, &m_pDlgExceptionList, IDS_EXCEPTION_LIST, 'e');
	Cmd(szMode, m_sTarget, "+e");
}

void FrameChan::OnChanInvite() 
{
	if (m_pDlgInviteList) {
		m_pDlgInviteList->SetForegroundWindow();
		return;
	}
	new CDlgBan(this, &m_pDlgInviteList, IDS_INVITE_LIST, 'I');
	Cmd(szMode, m_sTarget, "+I");
}

void FrameChan::OnTopic() 
{
	if (m_pDlgTopic) {
		m_pDlgTopic->SetForegroundWindow();
		return;
	}
	new DlgTopic(this);
}

void FrameChan::OnOplist() 
{
	DlgOPList dlg(this);
	dlg.DoModal();
}

void FrameChan::OnInvite() 
{
	new DlgInvite(this);
}

LRESULT FrameChan::OnNicklistRecreate(WPARAM, LPARAM)
{
	if (m_pNicks)
		m_pNicks->ReCreate();
	return 0;
}

LRESULT FrameChan::OnDeferChanMode(WPARAM, LPARAM)
{
	ModeAutoOP();
	return 0;
}

void FrameChan::OnViewSplit() 
{
	m_split.DoKeyboardSplit();
}

#if 0
void FrameChan::Simple(BOOL f)
{
	CFrame::Simple(f);

	if (!f)
		m_split.RecalcLayout();
}
#endif

extern TCHAR BASED_CODE szWindow[];
static char szFmtWindowKey[] = "%s-%s";
static char szFmtChanRect[] = "%d,%d,%d,%d,%d,%d,%d,%d";

BOOL FrameChan::PreCreateWindow(CREATESTRUCT& cs) 
{
	m_sizeText = m_sizeNicks = CSize(0, 0);

	CString sKey;
	sKey.Format(szFmtWindowKey, m_sFrameName, m_sTarget);
	CString s = theApp.GetProfileString(szWindow, sKey);
	if (!s.IsEmpty()) {
		CRect rcWork(0, 0, 0, 0);
		::SystemParametersInfo(SPI_GETWORKAREA, 0, &rcWork, 0);
		CRect rc;
		if (sscanf(s, szFmtChanRect, 
				&rc.left, &rc.top,
				&rc.right, &rc.bottom,
				&m_sizeText.cx, &m_sizeText.cy,
				&m_sizeNicks.cx, &m_sizeNicks.cy) == 8) {
			cs.x = rcWork.left + rc.left;
			cs.y = rcWork.top + rc.top;
			cs.cx = rc.Width();
			cs.cy = rc.Height();
			m_fRectCalc = TRUE;		// base class doesn't calc any more
		}
		MoveIntoDesktop(cs.x, cs.y, cs.cx, cs.cy);
	}

	return CFrame::PreCreateWindow(cs);
}

void FrameChan::OnDestroy() 
{
	WINDOWPLACEMENT wp;
	if (GetWindowPlacement(&wp)) {
		CRect rc;
		if (m_pText)
			m_pText->GetWindowRect(&rc);
		else
			rc.SetRectEmpty();
		m_sizeText = CSize(rc.Width(), rc.Height());
		if (m_pNicks)
			m_pNicks->GetWindowRect(&rc);
		else
			rc.SetRectEmpty();
		m_sizeNicks = CSize(rc.Width(), rc.Height());

		rc = wp.rcNormalPosition;
		CString sKey;
		sKey.Format(szFmtWindowKey, m_sFrameName, m_sTarget);
		CString s;
		s.Format(szFmtChanRect,
			rc.left, rc.top, rc.right, rc.bottom,
			m_sizeText.cx, m_sizeText.cy,
			m_sizeNicks.cx, m_sizeNicks.cy);
		theApp.WriteProfileString(szWindow, sKey, s);
	}

	CFrame::OnDestroy();
}
