#include "stdafx.h"
#include "mchat.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(FrameTalk, CFrame)
	//{{AFX_MSG_MAP(FrameTalk)
	ON_COMMAND(ID_IGNORE, OnIgnore)
	ON_COMMAND(ID_WHOIS, OnWhois)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

FrameTalk::FrameTalk(LPCTSTR pszTarget)
	: CFrame(TypeTalk, IDR_TALK, "Talk", pszTarget)
{
	LoadFrame(IDR_TALK, WS_OVERLAPPEDWINDOW);

	ShowWindow(SW_SHOW);
	UpdateWindow();
}

BOOL FrameTalk::SendData(LPCTSTR pStr)
{
	if ((sock.GetStatus() & SOCK_CONNECT) == 0)
		return FALSE;
	CmdTrail("PRIVMSG", m_sTarget, pStr);
	LineText(g_con.m_sNick, pStr);
	return TRUE;
}

BOOL FrameTalk::HasNick(LPCTSTR pNick)
{
	return m_sTarget.CompareNoCase(pNick) == 0;
}

void FrameTalk::MsgNick(LPCTSTR pNick, LPCTSTR pNickTo)
{
	m_sTarget = pNickTo;
	g_frames.ChangeKey(this);
	MakeTitle();
	CFrame::MsgNick(pNick, pNickTo);
}

void FrameTalk::RplWho(LPCTSTR pChan, const CUser& user)
{
	if (m_sTarget.CompareNoCase(user.m_sNick) == 0)
		m_sAddr = user.m_sAddr;
}

void FrameTalk::OnIgnore() 
{
	if (m_sAddr.IsEmpty()) {
		IgnorePopup(this);
		return;
	}
	CString s;
	s.Format("*!%s", m_sAddr);
	IgnorePopup(this, s);
}

void FrameTalk::OnWhois() 
{
	CmdWhois(m_sTarget);
}
