#include "stdafx.h"
#include "mchat.h"
#include "ident.h"

#define PORT_IDENT		113

class CIdentData : public CAsyncSocket
{
public:
protected:
	void OnReceive(int n);
};

CIdent ident;

CIdent::CIdent()
{
	m_fListening = FALSE;
}

CIdent::~CIdent()
{
	End();
}

void CIdent::Clear()
{
	while (!m_lData.IsEmpty())
		delete m_lData.RemoveHead();
}

void CIdent::Msg(LPCTSTR pStr, int nCode)
{
	if (nCode == -1)
		nCode = GetLastError();
	CString s;
	s.Format("$ Identd: %s: %d", pStr, nCode);
	g_pFrame->LineError(s);
}

void CIdent::Start()
{
	if (m_hSocket == INVALID_SOCKET && !Create(PORT_IDENT)) {
		Msg("Cannot create socket");
		return;
	}
	if (!Listen()) {
		Msg("Listen failed");
		return;
	}
	m_fListening = TRUE;
}

void CIdent::End()
{
	if (m_fListening)
		Close();
	Clear();
	m_fListening = FALSE;
}

void CIdent::OnAccept(int n)
{
	if (n != 0) {
		Msg("On-Accept", n);
		return;
	}
	CIdentData* pData = new CIdentData;
	if (!Accept(*pData)) {
		Msg("Accept");
		return;
	}
	m_lData.AddTail(pData);
	pData->AsyncSelect();
}

void CIdent::RemoveMe(CIdentData* pData)
{
	POSITION pos = m_lData.Find(pData);
	if (!pos)
		return;
	m_lData.RemoveAt(pos);
	delete pData;
}

void CIdentData::OnReceive(int n)
{
	if (n) {
		ident.Msg("On-Receive", n);
		ident.RemoveMe(this);
		return;
	}
	char aBuf[128];
	int nRcv = Receive(aBuf, sizeof aBuf - 1);
	while (nRcv > 0) {
		char c = aBuf[nRcv - 1];
		if (c == '\r' || c == '\n')
			nRcv--;
		else
			break;
	}
	if (nRcv > 0) {
		aBuf[nRcv] = 0;
		CString s;
		s.Format("%s : USERID : UNIX : %s\r\n", aBuf, g_opt.sLoginName);
		if (Send((LPCTSTR)s, s.GetLength()) == SOCKET_ERROR)
			ident.Msg("Send");
	} else
		ident.Msg("Receive");
	ident.RemoveMe(this);
}
