// ListChan.cpp : implementation file
//

#include "stdafx.h"
#include "mchat.h"
#include "ListChan.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define COL_CHANNAME	0
#define COL_NUMPPL		1
#define COL_TITLE		2

#define WID_CHANNAME	160
#define WID_NUMPPL		40

CStdioFile g_fileListChan;

/////////////////////////////////////////////////////////////////////////////
// CListChan

CListChan::CListChan()
{
}

CListChan::~CListChan()
{
}


BEGIN_MESSAGE_MAP(CListChan, CListCtrl)
	//{{AFX_MSG_MAP(CListChan)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnDblclk)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListChan message handlers

int CListChan::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CListCtrl::OnCreate(lpCreateStruct) == -1)
		return -1;

	int cx = lpCreateStruct->cx;

	InsertColumn(COL_CHANNAME, _T("Channel"),
		LVCFMT_LEFT, WID_CHANNAME, 0);
	InsertColumn(COL_NUMPPL, _T("#"),
		LVCFMT_LEFT, WID_NUMPPL, 1);
	cx -= (WID_CHANNAME + WID_NUMPPL);
	if (cx < 0)
		cx = 0;
	InsertColumn(COL_TITLE, _T("Title"), LVCFMT_LEFT, cx, 2);

	LV_ITEM item;
	memset(&item, 0, sizeof item);

	TRY {
		g_fileListChan.SeekToBegin();
		CString s;
		while (g_fileListChan.ReadString(s)) {
			LPCTSTR pStr = s;
			CString sChan(Token(pStr));
			CString sNum(Token(pStr));
			int n = InsertItem(0, sChan);
			if (n < 0)
				continue;
			SetItemText(n, COL_NUMPPL, sNum);
			SetItemText(n, COL_TITLE, pStr);
		}
	} CATCH(CFileException, e) {
	} END_CATCH
	return 0;
}

void CListChan::OnSize(UINT nType, int cx, int cy) 
{
	CListCtrl::OnSize(nType, cx, cy);
	if (nType != SIZE_RESTORED && nType != SIZE_MAXIMIZED)
		return;

	int n = cx - GetColumnWidth(COL_CHANNAME)
				- GetColumnWidth(COL_NUMPPL);
	if (GetColumnWidth(COL_TITLE) < n)
		SetColumnWidth(COL_TITLE, n);
}

void CListChan::OnDblclk(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int n = GetNextItem(-1, LVNI_FOCUSED);
	if (n >= 0) {
		CString sChan(GetItemText(n, COL_CHANNAME));
		CmdJoin(sChan);
	}
	*pResult = 0;
}

// CWndListChan

CWndListChan::CWndListChan()
{
	LPCTSTR pClass = AfxRegisterWndClass(
		CS_DBLCLKS|CS_HREDRAW|CS_PARENTDC|CS_VREDRAW);
	CRect rcTop;
	GetDesktopWindow()->GetWindowRect(&rcTop);
	CRect rc;
	rc.left = rcTop.Width() / 6;
	rc.top = rcTop.Height() / 4;
	rc.right = rcTop.Width() * 5 / 6;
	rc.bottom = rcTop.Height() * 3 / 4;

	CMenu menu;
	menu.LoadMenu(IDR_LISTCHAN);
	HMENU hMenu = menu.m_hMenu;
	menu.Detach();
	CreateEx(0, pClass, _T("Channel List"),
		WS_BORDER|WS_CAPTION|WS_OVERLAPPEDWINDOW|WS_VISIBLE,
		rc.left, rc.top, rc.Width(), rc.Height(),
		NULL, hMenu);
}

CWndListChan::~CWndListChan()
{
}


BEGIN_MESSAGE_MAP(CWndListChan, CWnd)
	//{{AFX_MSG_MAP(CWndListChan)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_FILE_CLOSE, OnFileClose)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CWndListChan message handlers

int CWndListChan::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	RECT rc;
	GetClientRect(&rc);
	if (!m_lsChan.Create(
			WS_VISIBLE|LVS_REPORT|LVS_SORTASCENDING,
			rc, this, 0))
		return -1;

	return 0;
}

void CWndListChan::OnSize(UINT nType, int cx, int cy) 
{
	CWnd::OnSize(nType, cx, cy);
	if (nType != SIZE_RESTORED && nType != SIZE_MAXIMIZED)
		return;

	RECT rc;
	GetClientRect(&rc);
	m_lsChan.MoveWindow(&rc);
}

void CWndListChan::OnFileSaveAs() 
{
	CFileDialog dlg(FALSE, _T("txt"), _T("ChannelList.txt"));
	if (dlg.DoModal() != IDOK)
		return;

	CString sFile(dlg.GetPathName());
	TRY {
		CStdioFile file(sFile, CFile::modeCreate | CFile::modeWrite);
		CString sChan;
		CString sNum;
		CString sTitle;
		CString sLine;
		int nItem = m_lsChan.GetItemCount();
		int i;
		for (i = 0; i < nItem; i++) {
			sChan = m_lsChan.GetItemText(i, COL_CHANNAME);
			sNum = m_lsChan.GetItemText(i, COL_NUMPPL);
			sTitle = m_lsChan.GetItemText(i, COL_TITLE);
			sLine = sChan + ' ' + sNum + ' ' + sTitle + '\n';
			file.WriteString(sLine);
		}
		file.Close();
	} CATCH(CFileException, e) {
		CString s;
		s.Format(IDS_ERR_FILE_WRITE, sFile);
		AfxMessageBox(s, MB_OK|MB_ICONEXCLAMATION);
	} END_CATCH
}

void CWndListChan::OnFileClose() 
{
	PostMessage(WM_CLOSE);
}
