// eLg[ANvg[`
// F܂ƂɎgȂ

#include "stdafx.h"
#include <string.h>

#include "MCrypt.h"

#ifdef MCRYPT_DEBUG
#include "HexDump.h"
#endif

typedef unsigned char Byte;

void MCrypt::MakeKey(const char* pStr)
{
	Reset();
	memset(m_table, 0, sizeof m_table);

	int iEnd = strlen(pStr);
	int i;
	int n;
	for (i = n = 0; n < iEnd; n++) {
		Byte nChar = ((const Byte*)pStr)[i];
		Enter(n, nChar);
		if (++i >= iEnd)
			i = 0;
	}

#ifdef MCRYPT_DEBUG
	HexDump hd;
	hd.Dump(m_table, sizeof m_table);
#endif
}

void MCrypt::Enter(int nIndex, unsigned char nChar)
{
	Byte nPlus = nChar + nIndex + 1;
	Byte n = nChar + nIndex;
	m_table[n] += nPlus;
	int i;
	for (i = 1; i < 128; i++) {
		nPlus += i;
		Byte nRight = n + i;
		Byte nLeft = n - i;
		Byte nTmp = m_table[nRight];
		m_table[nRight] = m_table[nLeft] + nPlus * 2;
		m_table[nLeft] = nTmp + nPlus;
	}
}

void MCrypt::Encode(const void* pSrc, int nSrc, void* pDst)
{
	const Byte* pIn = (const Byte*)pSrc;
	Byte* pOut = (Byte*)pDst;
	int i;
	for (i = 0; i < nSrc; i++) {
		*pOut++ = *pIn++ + m_table[m_nEnc];
		if (++m_nEnc >= 256)
			m_nEnc = 0;
	}
}

CString MCrypt::Encode(const CString& sSrc)
{
	int nSrc = sSrc.GetLength();
	CString sBuf;
	LPTSTR pBuf = sBuf.GetBuffer(nSrc);
	Encode((const void*)(LPCTSTR)sSrc, nSrc, pBuf);
	sBuf.ReleaseBuffer(nSrc);

	CString sDst;
	LPTSTR pDst = sDst.GetBuffer(nSrc * 2);
	const Byte* pByte = (const Byte*)(LPCTSTR)sBuf;
	int i;
	for (i = 0; i < nSrc; i++) {
		sprintf(pDst, "%02X", (int)*pByte++);
		pDst += 2;
	}
	sDst.ReleaseBuffer(nSrc * 2);
	return sDst;
}

void MCrypt::Decode(const void* pSrc, int nSrc, void* pDst)
{
	const Byte* pIn = (const Byte*)pSrc;
	Byte* pOut = (Byte*)pDst;
	int i;
	for (i = 0; i < nSrc; i++) {
		*pOut++ = *pIn++ - m_table[m_nDec];
		if (++m_nDec >= 256)
			m_nDec = 0;
	}
}

inline Byte hex2int(char c)
{
	return (c >= '0' && c <= '9') ? (c - '0')
		: (c >= 'a' && c <= 'f') ? (c - 'a' + 10)
		: (c >= 'A' && c <= 'F') ? (c - 'A' + 10)
		: 0;
}

CString MCrypt::Decode(const CString& sSrc)
{
	int nSrc = sSrc.GetLength() / 2;
	LPCTSTR pSrc = sSrc;
	Byte* pBuf = new Byte[nSrc + 1];

	int i;
	for (i = 0; i < nSrc; i++) {
		Byte n1 = hex2int(*pSrc++);
		Byte n2 = hex2int(*pSrc++);
		pBuf[i] = (n1 << 4) | n2;
	}

	CString sDst;
	LPTSTR pDst = sDst.GetBuffer(nSrc);
	Decode(pBuf, nSrc, pDst);
	sDst.ReleaseBuffer(nSrc);

	delete [] pBuf;
	return sDst;
}
