// NickList.h : header file
//

class CFrame;
class CApp;

// CNickList window

class CNickList : public CListCtrl
{
// Construction
public:
	DECLARE_DYNCREATE(CNickList)
	CNickList();

// Attributes
public:
	FrameChan* m_pFrame;

	BOOL m_fRedraw;
	BOOL m_fDragging;
	int m_iDragImage;
	int m_nDragOperation;
	CString m_sInviteTarget;
	CMap<CString, LPCTSTR, CUser*, CUser*&> mapNick;

// Operations
public:
	BOOL GetFocusedNick(CString& sNick);
	BOOL GetSelNickAddr(CString& sNick, CString& sAddr);
	BOOL GetSelPrefix(CString& sPrefix);
	int GetSelectedNames(CStringArray& ar);

	void Kick();
	void KickBan();
	void Invite(LPCTSTR psTarget);

	void Add(LPCTSTR pNick, LPCTSTR pAddr);
	void Add(const CUser& user);
	BOOL Del(LPCTSTR pNick);
	BOOL Rename(LPCTSTR pNick, LPCTSTR pNickTo);
	BOOL Modify(const CUser& user);
	void ModeOP(LPCTSTR pNick, BOOL f);
	void ModeAutoOP();
	void Reset();
	BOOL Exists(LPCTSTR pNick);
	void Redraw(BOOL fOn = TRUE);
	void ShowMenu();

protected:
	int GetIndex(LPCTSTR pNick, CUser*& pUser);
	CArray<int, int> m_arWidth;

	CUser* ClientPtToUser(const CPoint& pt);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNickList)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CNickList();

	// Generated message map functions
protected:
	//{{AFX_MSG(CNickList)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGetdispinfo(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnClick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclk(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnReturn(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

// CNickWnd window

class CNickWnd : public CWnd
{
// Construction
public:
	DECLARE_DYNCREATE(CNickWnd)
	CNickWnd();

// Attributes
public:

// Operations
public:
	void ReCreate();
	void FontChange();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNickWnd)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CNickWnd();

	CNickList m_list;

	// Generated message map functions
protected:
	//{{AFX_MSG(CNickWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
