// Text.h : header file
//

class CLine
{
public:
	CLine(LPCTSTR pNick, LPCTSTR pStr, Fonts::FType type);
	~CLine();

	int SameChars(CDC& dc, int nCol, int nLen, BYTE* pAt = NULL);
	int FitInWidth(CDC& dc, int nWidth, int nCol, int nLen, int& nHeight);
	void SetDim(CDC& dc, int nWidth, int &nOrd);
	void Draw(CDC& dc, CRect& rc, int nCol, int nLen);
	int Extent(CDC& dc, int nCol, int nLen);
	int GetCol(CDC& dc, int nWidth, int cx, int cy);

	CString m_sStr;
	BYTE* m_pbAt;
	Fonts::FType m_type;
	int m_nLines;
	int m_nOrdinate;
	int m_nHeight;

	BOOL HasKeyword() { return m_fKeyword; };
protected:
	BOOL m_fKeyword;
};

class TextFrame; //forward

// CText view

class CText : public CWnd
{
public:
	DECLARE_DYNCREATE(CText)
	CText();           // protected constructor used by dynamic creation
	virtual ~CText();

// Attributes
public:

// Operations
public:
	virtual BOOL Create(LPCTSTR lpszClass,
		LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect,
		CWnd* pParentWnd, UINT nID,
		CCreateContext* pContext = NULL);

	BOOL DoCreate(CFrame* parent, UINT nID);
	void FontChange();
	void SetParentFrame(CFrame* pFrame);

	void ShowLine(LPCTSTR pNick, LPCTSTR pStr, Fonts::FType type);

	//void Isolate(BOOL f);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CText)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	void MoveTop();
	void MoveBottom();
	void MovePageUp();
	void MovePageDown();
	void MoveLineUp();
	void MoveLineDown();

protected:
	void NewSize();
	void DrawLine(CDC& dc, int nY, CLine* pLine, int iLine);
	BOOL GetLineCol(CPoint& pt, int &iLine, int &nCol);
	BOOL GetSelBgnEnd();
	void SelCopy();

	void CalcViewTo();
	void CalcViewFrom();

	BOOL m_fCapture;
	int m_iSelLine;
	int m_iSelLine1;
	int m_nSelCol;
	int m_nSelCol1;
	int m_iSelLineBgn;
	int m_iSelLineEnd;
	int m_nSelColBgn;
	int m_nSelColEnd;

	int m_nClientWidth;
	int m_nClientHeight;
	int m_nCharHeight;
	int m_nCharWidth;
	int m_iViewFrom;
	int m_iViewTo;
	int m_nScrollRange;
	int m_nOrdMax;

	CArray<CLine*, CLine*> m_aLine;

	int m_nWheelDelta;

	// for text window isolation
	CFrame* m_pFrame;
	CWnd* m_pParent;	// is frame or splitter
	//TextFrame* m_pTextFrame;
	CString m_sTitle;	// copy of frame caption

	//void NewTitle(LPCTSTR pszTitle);

	// Generated message map functions
protected:
	//{{AFX_MSG(CText)
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	friend class CFrame;
};

#if 0
// TextFrame EBhE

class TextFrame : public CWnd
{
// RXgNV
public:
	TextFrame(CText* pText, CFrame* pFrame);

// Agr[g
public:
	BOOL Show(LPCTSTR pszTitle);
	void Hide() { ShowWindow(SW_HIDE); };

	CText* m_pText;
	CFrame* m_pFrame;

protected:
	BOOL m_fCreated;

	void CalcRect(CRect& rc);
	BOOL DoCreate(LPCTSTR pszTitle, CRect& rc);

// Iy[V
public:
	void NewSize(void);

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(TextFrame)
	//}}AFX_VIRTUAL

// Cve[V
public:
	virtual ~TextFrame();

	// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(TextFrame)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnNcMouseMove(UINT nHitTest, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
#endif
