#include "stdafx.h"
#include "mchat.h"

// beep

static TCHAR BASED_CODE szOptBeep[] = _T("Options\\Beep");

TagBeep::TagBeep(BeepInit& init)
{
	m_sLabel = init.szLabel;
	m_sRegBeep = init.szRegBeep;
	m_sRegWave = init.szRegWave;
	m_nBeep = init.nBeep;
	m_fBeep = theApp.GetProfileInt(szOptBeep, m_sRegBeep, init.fBeepDefault);
	m_sWave = theApp.GetProfileString(szOptBeep, m_sRegWave);
	m_fWave = !m_sWave.IsEmpty();
}

void TagBeep::Save()
{
	theApp.WriteProfileInt(szOptBeep, m_sRegBeep, m_fBeep);
	theApp.WriteProfileString(szOptBeep, m_sRegWave, m_sWave);
}

OptBeep optBeep;		// beep option

static struct BeepInit arBeepInit[] = {
	{ _T("Connect"), _T("Connect"), _T("ConnectFile"),
		TRUE, MB_ICONHAND },
	{ _T("Disconnect"), _T("Disconnect"), _T("DisconnectFile"),
		TRUE, MB_ICONHAND },
	{ _T("Kicked by somebody"), _T("Kicked"), _T("KickedFile"),
		TRUE, MB_ICONHAND },
	{ _T("Invited"), _T("Invited"), _T("InvitedFile"),
		TRUE, MB_ICONHAND },
	{ _T("Private message"), _T("PrivMsg"), _T("PrivMsgFile"),
		FALSE, MB_ICONHAND },
	{ _T("New private message"), _T("PrivMsgNoTalk"), _T("PrivMsgNoTalkFile"),
		TRUE, MB_ICONHAND },
	{ _T("Private message (icon)"),
		_T("PrivMsgIcon"), _T("PrivMsgIconFile"),
		FALSE, MB_ICONHAND },
	{ _T("Channel message"), _T("ChanMsg"), _T("ChanMsgFile"),
		FALSE, MB_ICONHAND },
	{ _T("Channel message (icon)"),
		_T("ChanMsgIcon"), _T("ChanMsgIconFile"),
		FALSE, MB_ICONHAND },
	{ _T("DCC request receive"), _T("DCC"), _T("DCCFile"),
		FALSE, MB_ICONHAND },
	{ _T("Found Nick"), _T("FoundNick"), _T("FoundNickFile"),
		TRUE, MB_ICONASTERISK },
	{ _T("Join"), _T("Join"), _T("JoinFile"), FALSE, MB_ICONHAND },
	{ _T("Part"), _T("Part"), _T("PartFile"), FALSE, MB_ICONHAND },
	{ _T("Quit"), _T("Quit"), _T("QuitFile"), FALSE, MB_ICONHAND },
	{ _T("Keyword"), _T("Keyword"), _T("KeywordFile"), TRUE, MB_ICONHAND },
	{ _T("Nick change"), _T("NickChange"), _T("NickChangeFile"),
		FALSE, MB_ICONHAND },
};

void OptBeep::Load()
{
	int i;
	for (i = 0; i < sizeof arBeepInit / sizeof arBeepInit[0]; i++) {
		TagBeep tag(arBeepInit[i]);
		Add(tag);
	}
}

void OptBeep::Save()
{
	int i;
	for (i = 0; i < GetSize(); i++)
		ElementAt(i).Save();
}

BOOL OptBeep::Play(int nPlay)
{
	if (nPlay < 0 || nPlay >= GetSize()) {
		TRACE("OptBeep Play# out of range. %d\n", nPlay);
		return FALSE;
	}
	TagBeep& tagBeep = ElementAt(nPlay);
	if (!tagBeep.m_fBeep)
		return FALSE;
	if (!tagBeep.m_fWave) {
		MessageBeep(tagBeep.m_nBeep);
		return TRUE;
	}
	PlaySound(tagBeep.m_sWave, NULL, SND_ASYNC|SND_FILENAME|SND_NOWAIT);
	return TRUE;
}
