#include "match.h"

class Chan
{
public:
	Chan();
	Chan(LPCTSTR pszChan, BOOL fAutoJoin = FALSE);
	Chan(const Chan& chan);

	void Clear();
	void SetMode(ChanMode* pMode);
	void SetMode(LPCTSTR pszMode);
	void SetTopic(LPCTSTR pszTopic) {
		if (pszTopic)
			m_sTopic = pszTopic;
		else
			m_sTopic.Empty();
	}

	void Parse(const CString& s, LPCTSTR pParm);
	BOOL Write(CStdioFile& file);

	CString m_sChan;
	BOOL m_fAutoJoin;
	ChanMode* m_pMode;
	CString m_sTopic;
	LsNickMatch m_lsOpPlus;
};

void AFXAPI DestructElements(Chan** ppChan, int nCount );

class MapChan : public CMap<CString, LPCTSTR, Chan*, Chan*&>
{
public:
	int Load();
	BOOL Save();

	Chan* Append(LPCTSTR pszChan);
	void Delete(LPCTSTR pszChan);

	void SetAutoJoin(LPCTSTR pszChan, BOOL fAutoJoin);
	void SetMode(LPCTSTR pszChan, ChanMode* pMode);
	void SetTopic(LPCTSTR pszChan, LPCTSTR pszTopic);

	void AutoJoin();
};

extern MapChan g_mapChan;

//
// DlgOPList _CAO
//

class FrameChan;

class DlgOPList : public CDialog
{
// RXgNV
public:
	DlgOPList(FrameChan* pFrame, LPCTSTR pText = 0);

// _CAO f[^
	//{{AFX_DATA(DlgOPList)
	enum { IDD = IDD_OPLIST };
	CButton	m_btnDel;
	CButton	m_btnAdd;
	CEdit	m_edOpList;
	CListBox	m_lbOpList;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(DlgOPList)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	FrameChan* m_pFrame;
	LsNickMatch m_lsOpAdd;
	LsNickMatch m_lsOpDel;

	CString m_sInitialText;

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(DlgOPList)
	virtual BOOL OnInitDialog();
	afx_msg void OnOplistAdd();
	afx_msg void OnOplistDel();
	virtual void OnOK();
	afx_msg void OnChangeOplistEdit();
	afx_msg void OnSelchangeOplistList();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
