#include "stdafx.h"
#include "conv.h"

BOOL g_fConv1ByteKana = TRUE;

#define ESC			0x1B
#define NONE		0

#define S_LEAD		0x01
#define S_INJIS		0x10

void sjis2jis(const BYTE* p1, int& rn1, BYTE* p2, int& rn2)
{
	const BYTE* p1End = p1 + rn1;
	BYTE* p2End = p2 + rn2 - 5;
	int n1 = 0;
	int n2 = 0;
	WORD stat = 0;

	while (p1 < p1End && p2 < p2End) {
		BYTE c = *p1++;
		n1++;
		if ((stat & S_LEAD) != 0) {
			stat &= ~S_LEAD;
			if (_ismbbtrail(c)) {
second_byte:
				if ((stat & S_INJIS) == 0) {
					*p2++ = ESC;
					*p2++ = '$';
					*p2++ = 'B';
					n2 += 3;
					stat |= S_INJIS;
				}
				WORD w = _mbcjmstojis(stat & 0xFF00 | c);
				*p2++ = HIBYTE(w);
				*p2++ = LOBYTE(w);
				n2 += 2;
				continue;
			}
			*p2++ = HIBYTE(stat);
			n2++;
		}
		if (_ismbblead(c)) {
			stat = ((c << 8) | S_LEAD | LOBYTE(stat));
			continue;
		}
		if (g_fConv1ByteKana && _ismbbkana(c)) {
			WORD cc = _mbbtombc(c);
			stat = ((cc & 0xff00) | LOBYTE(stat));
			c = (BYTE)cc;
			goto second_byte;
		}
		if ((stat & S_INJIS) != 0) {
			*p2++ = ESC;
			*p2++ = '(';
			*p2++ = 'B';
			n2 += 3;
			stat &= ~S_INJIS;
		}
		*p2++ = c;
		n2++;
		stat = NONE;
	}
	rn1 = n1;
	rn2 = n2;
}

#define ST_MASK		0x0F
#define ST_ESC		0x01
#define ST_DOL		0x02
#define ST_PAR		0x04

#define IN_MASK		0xF0
#define IN_ASC		0x00
#define IN_JIS		0x10

void jis2sjis(const BYTE* p1, int& rn1, BYTE* p2, int& rn2)
{
	const BYTE* p1End = p1 + rn1;
	BYTE* p2End = p2 + rn2 - 5;
	int n1 = 0;
	int n2 = 0;
	BYTE bStat = 0;
	BYTE bIn = 0;
	BYTE bLead = 0;

	while (p1 < p1End && p2 < p2End) {
		BYTE c = *p1++;
		n1++;
		WORD w;

		if (bLead) {
			w = _mbcjistojms((bLead << 8)| c);
			*p2++ = HIBYTE(w);
			*p2++ = LOBYTE(w);
			n2 += 2;
			bLead = 0;
			continue;
		}
retry:
		switch (bStat & ST_MASK) {
		case ST_ESC:
			if (c == '$') {
				bStat = ST_DOL;
				continue;
			} else if (c == '(') {
				bStat = ST_PAR;
				continue;
			}
			*p2++ = ESC;
			n2++;
			bStat = NONE;
			goto retry;
		case ST_DOL:
			if (c == 'B' || c == '@') {
				bIn = IN_JIS;
				bStat = NONE;
				continue;
			}
			*p2++ = ESC;
			*p2++ = '$';
			n2 += 2;
			bStat = NONE;
			goto retry;
		case ST_PAR:
			if (c == 'B' || c == 'J') {
				bIn = IN_ASC;
				bStat = NONE;
				continue;
			}
			*p2++ = ESC;
			*p2++ = '(';
			n2 += 2;
			bStat = NONE;
			goto retry;
		default:
			if (c == ESC) {
				bStat = ST_ESC;
				continue;
			}
			if (bIn == IN_JIS) {
				bLead = c;
				continue;
			}
			*p2++ = c;
			n2++;
		}
	}
	rn1 = n1;
	rn2 = n2;
}
