#include "stdafx.h"
#include "mchat.h"

// Keyword
ArKeyword g_arKeyword;

void ArKeyword::Load()
{
	RemoveAll();
	CString sFile(GetDataPathname(IDS_FILE_KEYWORD));
	CStdioFile file;
	if (!file.Open(sFile,
			CFile::modeRead | CFile::shareDenyWrite | CFile::typeText))
		return;

	CString sBuf;
	for (;;) {
		BOOL fRead;
		TRY {
			fRead = file.ReadString(sBuf);
		} CATCH(CFileException, e) {
			fRead = FALSE;
		} END_CATCH
		if (!fRead)
			break;
		Add(sBuf);
	}
}

void ArKeyword::Save()
{
	CString sFile(GetDataPathname(IDS_FILE_KEYWORD));
	CStdioFile file;
	if (!file.Open(sFile,
			CFile::modeCreate | CFile::modeWrite | CFile::typeText)) {
		CString s;
		s.Format(IDS_ERR_FILE_WRITE, sFile);
		g_pFrame->LineError(s);
		return;
	}

	int i;
	for (i = 0; i < GetSize(); i++) {
		CString s = ElementAt(i) + "\n";
		TRY {
			file.WriteString(s);
		} CATCH(CFileException, e) {
		} END_CATCH
	}
}

int ArKeyword::Search(LPCTSTR pStr, int nCol, int& nStart)
{
	LPCTSTR psz = pStr + nCol;
    nStart = INT_MAX;
    int nLen = 0;
	int i;
    for (i = 0; i < GetSize(); i++) {
        CString& rs = ElementAt(i);
        LPCTSTR p = (LPCTSTR)_mbsstr((BYTE*)psz, (BYTE*)(LPCTSTR)rs);
        if (!p)
			continue;
        int n = p - pStr;
        if (n < nStart) {
            nStart = n;
            nLen = rs.GetLength();
        } else if (n == nStart && rs.GetLength() > nLen)
			nLen = rs.GetLength();
    }
    return nLen;
}
