
class Match
{
public:
	Match();

	void Set(LPCTSTR pszPtn);

	BOOL IsMatch(LPCTSTR pszStr) const;
	BOOL IsSame(const Match& m) const;
	operator CString() const;

protected:
	enum {
		TypeNone = 0,	// match nothing
		TypeAny,		// match everything
		TypeFull,		// full compare
		TypeHead,		// head match
		TypeTail,		// tail match
	} m_nType;

	CString m_sPtn;
};

class NickAddr
{
public:
	NickAddr(LPCTSTR pStr) { Set(pStr); }

	void Set(LPCTSTR pStr);
	CString GetString();

	CString m_sNick;
	CString m_sAccount;
	CString m_sAddress;
};

class NickMatch
{
public:
	NickMatch() {}
	NickMatch(LPCTSTR psz) { Set(psz); }

	void Set(LPCTSTR pszPtn);

	BOOL IsMatch(LPCTSTR psz) const;
	CString GetString() const;
	BOOL IsSame(const NickMatch& nm) const;

protected:
	Match m_nick;
	Match m_account;
	Match m_address;
};

class LsNickMatch : public CList<NickMatch, NickMatch&>
{
public:
	POSITION Find(const NickMatch& nmFind);
	void Copy(const LsNickMatch& ls);
	BOOL IsMatch(LPCTSTR psz);
};
