
#ifndef _PLUG_H_
#define _PLUG_H_

// connection status
struct Con {
	CString m_sNick; // my nick
	BOOL m_fInConversation; // b/w end-of-motd to disconnect
	BOOL m_fAway;			// currently away mode
	CString m_sLastAway;		// last away message
	CString m_sNickBeforeAway;	// to restore nick when cancel away
	BOOL m_fReconnecting;	// now on auto-reconnect process
	BOOL m_fQuitting;		// now on quit process
	CString m_sChannelDefault;	// last joined channel
	BOOL m_fDccFakeWhois;	// sent whois to retrieve my address
	int m_nConnectRetry;	// connect retry counter
#define CONNECT_RETRY_MAX	10

	Con() {
		m_fInConversation = m_fAway = m_fReconnecting = m_fQuitting = m_fDccFakeWhois = FALSE;
		m_nConnectRetry = 0;
	}
};

// received data from server
struct Packet {
	CString sPrefix;	// hole prefix
	CString sNick;		// nick part of prefix
	CString sAddr;		// user@host.domain part of prefix
	CString sHost;		// host.domain part of prefix
	CString sCmd;		// command part
	CString sParm;		// parameters
	CString sTrail;		// trails after ':'
};

typedef void (*PLUG_PROP_PROT)(void);
typedef void (*PLUG_ON_PRIV)(const Con& con, const Packet& pac,
							 const CString& sTarget, const CString& sMsg);

class Plug : public CObject
{
public:
	Plug(LPCTSTR pszFile);
	~Plug();

	BOOL Load();

public: // set by plug
	CString m_sName;
	PLUG_PROP_PROT Property;
	PLUG_ON_PRIV OnPriv;

private:
	CString m_sFile;
	HMODULE m_hModule;
};

#define PLUG_INIT_NAME	"PlugInit"
#define PLUG_INIT_FUNC	PlugInit
typedef BOOL (*PLUG_INIT_PROT)(Plug*);

#endif //_PLUG_H_
