#include "stdafx.h"
#include "mchat.h"
#include "conv.h"

// server definition

SvrDef g_sd;

static TCHAR BASED_CODE szServer[] = _T("Server");
static TCHAR BASED_CODE szHostname[] = _T("Hostname");
static TCHAR BASED_CODE szPort[] = _T("Port");
static TCHAR BASED_CODE szPassword[] = _T("Password");

void CApp::LoadServerInfo()
{
	CString sHostname = GetProfileString(szServer, szHostname);
	int nPort = GetProfileInt(szServer, szPort, 6667);
	CString sPassword = GetProfileString(szServer, szPassword);

	if (nPort < 1)
		nPort = 6667;

	g_sd.Pack(sHostname, nPort, sPassword);
}

void CApp::SaveServerInfo()
{
	WriteProfileString(szServer, szHostname, g_sd.m_sHostname);
	WriteProfileInt(szServer, szPort, g_sd.m_nPort);
	WriteProfileString(szServer, szPassword, g_sd.m_sPassword);
}

// quit message
static TCHAR BASED_CODE szSettings[] = _T("Settings");
static TCHAR BASED_CODE szQuitMsg[] = _T("QuitMsg");
static TCHAR BASED_CODE szDefMsg[] = _T("Leaving..");

CString LoadQuitMsg()
{
	return theApp.GetProfileString(szSettings, szQuitMsg, szDefMsg);
}

void SaveQuitMsg(LPCTSTR pMsg)
{
	theApp.WriteProfileString(szSettings, szQuitMsg, pMsg);
}

// other options

OptionTag g_opt;

// user
static TCHAR BASED_CODE szUserInfo[] = _T("UserInfo");
static TCHAR BASED_CODE szNick[] = _T("Nick");
static TCHAR BASED_CODE szNick2[] = _T("Nick2");
static TCHAR BASED_CODE szNickAway[] = _T("NickAway");
static TCHAR BASED_CODE szRealName[] = _T("RealName");
static TCHAR BASED_CODE szLoginName[] = _T("LoginName");
static TCHAR BASED_CODE szUserMode[] = _T("UserMode");

// logging
static TCHAR BASED_CODE szOptLog[] = _T("Options\\Log");
static TCHAR BASED_CODE szLogMain[] = _T("LogMain");
static TCHAR BASED_CODE szLogChan[] = _T("LogChan");
static TCHAR BASED_CODE szLogTalk[] = _T("LogTalk");
static TCHAR BASED_CODE szFileMain[] = _T("FileMain");
static TCHAR BASED_CODE szDirChan[] = _T("DirChan");
static TCHAR BASED_CODE szDirTalk[] = _T("DirTalk");
static TCHAR BASED_CODE szLogExt[] = _T("Extension");
static TCHAR BASED_CODE szAppend[] = _T("Append");
static TCHAR BASED_CODE szLogExtDef[] = ".txt";
static TCHAR BASED_CODE szDate[] = _T("Date");
static TCHAR BASED_CODE szDateFormat[] = _T("DateFormat");
static TCHAR BASED_CODE szDateFormatDef[] = "-%y%m%d";
static TCHAR BASED_CODE szNewDate[] = _T("NewDate");

// title
static TCHAR BASED_CODE szOptTitle[] = _T("Options\\Title");
static TCHAR BASED_CODE szMain[] = _T("Main");
static TCHAR BASED_CODE szChan[] = _T("Chan");
static TCHAR BASED_CODE szTalk[] = _T("Talk");
static TCHAR BASED_CODE szChat[] = _T("Chat");

// format
static TCHAR BASED_CODE szOptMsg[] = _T("Options\\Messages");
static TCHAR BASED_CODE szJoin[] = _T("Join");
static TCHAR BASED_CODE szKick[] = _T("Kick");
static TCHAR BASED_CODE szMode[] = _T("Mode");
static TCHAR BASED_CODE szPart[] = _T("Part");
static TCHAR BASED_CODE szQuit[] = _T("Quit");
static TCHAR BASED_CODE szQuery[] = _T("Query");
static TCHAR BASED_CODE szTopic[] = _T("Topic");
static TCHAR BASED_CODE szJoinAddr[] = _T("JoinAddr");
static TCHAR BASED_CODE szTime[] = _T("Time");
static TCHAR BASED_CODE szTimeFmt[] = _T("TimeFormat");
static TCHAR BASED_CODE szNickFmt[] = _T("NickFormat");
static TCHAR BASED_CODE szReplyToMain[] = _T("ReplyToMain");

// event
static TCHAR BASED_CODE szOptEvent[] = _T("Options\\Event");
static TCHAR BASED_CODE szPrivMsgPopup[] = _T("PrivMsgPopup");
static TCHAR BASED_CODE szPrivMsgWhois[] = _T("PrivMsgWhois");
static TCHAR BASED_CODE szInvite[] = _T("Invite");
static TCHAR BASED_CODE szDccChat[] = _T("DccChat");
static TCHAR BASED_CODE szReconnect[] = _T("Reconnect");
static TCHAR BASED_CODE szRejoin[] = _T("Rejoin");
static TCHAR BASED_CODE szFlashInactive[] = _T("FlashInactive");
static TCHAR BASED_CODE szFlashMinimized[] = _T("FlashMinimized");
static TCHAR BASED_CODE szRestoreMinimized[] = _T("RestoreMinimized");
//static TCHAR BASED_CODE szContinuousFlash[] = _T("ContinuousFlash");

// nicks
static TCHAR BASED_CODE szOptIsOn[] = _T("Options\\IsOn");
static TCHAR BASED_CODE szIsOnQuit[] = _T("CheckQuit");
static TCHAR BASED_CODE szIsOnPopup[] = _T("Popup");
static TCHAR BASED_CODE szIsOnInterval[] = _T("Interval");

// beep
// defined at other place

// NickList
static TCHAR BASED_CODE szOptNickList[] = _T("Options\\NickList");
static TCHAR BASED_CODE szItems[] = _T("Items");
static TCHAR BASED_CODE szPosition[] = _T("Position");

// Keyword
static TCHAR BASED_CODE szOptKeyword[] = _T("Options\\Keyword");
static TCHAR BASED_CODE szWholeLine[] = _T("WholeLine");
static TCHAR BASED_CODE szRestore[] = _T("Restore");

// dcc
static TCHAR BASED_CODE szOptDcc[] = _T("Options\\DCC");
static TCHAR BASED_CODE szDccSendPackets[] = _T("DccSendPackets");
static TCHAR BASED_CODE szChatEOL[] = _T("ChatEOL");
static TCHAR BASED_CODE szChatCode[] = _T("ChatCode");
static TCHAR BASED_CODE szUseFakeAddr[] = _T("UseFakeAddr");
static TCHAR BASED_CODE szUseFakeAuto[] = _T("UseFakeAuto");
static TCHAR BASED_CODE szFakeAddr[] = _T("FakeAddr");
//static TCHAR BASED_CODE szPort[] = _T("Port");

// others
static TCHAR BASED_CODE szOption[] = _T("Options");
static TCHAR BASED_CODE szDestNick[] = _T("DestNick");
static TCHAR BASED_CODE szMinimizeByReturnKey[] = _T("MinimizeByReturnKey");
static TCHAR BASED_CODE szIdentd[] = _T("Identd");
static TCHAR BASED_CODE szConnectOnStartup[] = _T("ConnectOnStartup");
static TCHAR BASED_CODE szKana1Byte[] = _T("Kana1ByteConv");
static TCHAR BASED_CODE szServerCollection[] = _T("ServerCollection");
static TCHAR BASED_CODE szMinimizeMain[] = _T("MinimizeMain");
static TCHAR BASED_CODE szHideMain[] = _T("HideMain");
static TCHAR BASED_CODE szAutoSimple[] = _T("AutoSimple");
static TCHAR BASED_CODE szWhoisDetail[] = _T("WhoisDetail");
static TCHAR BASED_CODE szConfirmPaste[] = _T("ConfirmPaste");
static TCHAR BASED_CODE szImeOn[] = _T("ImeOn");
static TCHAR BASED_CODE szBrowser[] = _T("Browser");
static TCHAR BASED_CODE szControlChar[] = _T("ControlChar");

static TCHAR BASED_CODE szDebug[] = _T("Debug");

inline LPCTSTR NextNum(LPCTSTR p)
{
	if (p) {
		while (*p) {
			if (isdigit(*p))
				return p;
			p++;
		}
	}
	return 0;
}

static void OptLoadNickList()
{
	ArNLItem& ar = g_opt.arNLItem;
	CString s = theApp.GetProfileString(szOptNickList, szItems);
	if (s.IsEmpty()) {
		ar.Add(NL_NICK);
		return;
	}
	LPCTSTR p = s;
	while ((p = NextNum(p)) != 0) {
		int nNL = atoi(p);
		if (nNL < 0 || nNL >= NL_END)
			continue;
		BOOL fDuplicate = FALSE;
		int i;
		for (i = 0; i < ar.GetSize(); i++) {
			if (ar[i] == nNL) {
				fDuplicate = TRUE;
				break;
			}
		}
		if (fDuplicate)
			continue;
		ar.Add(nNL);
		while (isdigit(*p))
			p++;
	}
}

LPCTSTR GetNLString(int nNL, int* pnWidth)
{
	LPCTSTR pLabel;
	int nWid;
	switch (nNL) {
	case NL_NICK:
		pLabel = _T("Nick");
		nWid = 40;
		break;
	case NL_ADDR:
		pLabel = _T("Address");
		nWid = 80;
		break;
	case NL_NAME:
		pLabel = _T("Name");
		nWid = 80;
		break;
	case NL_SERV:
		pLabel = _T("Server");
		nWid = 80;
		break;
	default:
		ASSERT(FALSE);
		pLabel = _T("?");
		nWid = 10;
	}
	if (pnWidth)
		*pnWidth = nWid;
	return pLabel;
}

void CApp::LoadOptions()
{
	CString s;

	// user
	g_opt.sNick = GetProfileString(szUserInfo, szNick, "MyNick");
	g_opt.sNick2 = GetProfileString(szUserInfo, szNick2, "");
	g_opt.sNickAway = GetProfileString(szUserInfo, szNickAway, "");
	g_opt.sRealName = GetProfileString(szUserInfo, szRealName, "My Real Name");
	g_opt.sUserInfo = GetProfileString(szUserInfo, szUserInfo);
	g_opt.sLoginName = GetProfileString(szUserInfo, szLoginName, g_con.m_sNick);
	g_opt.sHostName = GetProfileString(szUserInfo, szHostname);
	s = GetProfileString(szUserInfo, szUserMode);
	g_opt.usermode.FromString(s);

	// log
	g_opt.fLogMain = GetProfileInt(szOptLog, szLogMain, FALSE);
	g_opt.fLogChan = GetProfileInt(szOptLog, szLogChan, FALSE);
	g_opt.fLogTalk = GetProfileInt(szOptLog, szLogTalk, FALSE);
	s = GetDataPathname(IDS_FILE_LOGMAIN);
	g_opt.sFileMain = GetProfileString(szOptLog, szFileMain, s);
	GetDataDir(s);
	DirExtend(s, "log");
	g_opt.sDirChan = GetProfileString(szOptLog, szDirChan, s);
	g_opt.sDirTalk = GetProfileString(szOptLog, szDirTalk, s);
	g_opt.sLogExt = GetProfileString(szOptLog, szLogExt, szLogExtDef);
	g_opt.fAppend = GetProfileInt(szOptLog, szAppend, TRUE);
	g_opt.fLogDate = GetProfileInt(szOptLog, szDate, FALSE);
	g_opt.sLogDateFormat = GetProfileString(szOptLog, szDateFormat, szDateFormatDef);
	g_opt.fLogNewDate = GetProfileInt(szOptLog, szNewDate, FALSE);

	g_opt.fDebugLog = GetProfileInt(szOption, szDebug, FALSE);

	// title
	s.LoadString(IDS_TITLE_MAIN);
	g_opt.sMain = GetProfileString(szOptTitle, szMain, s);
	s.LoadString(IDS_TITLE_CHAN);
	g_opt.sChan = GetProfileString(szOptTitle, szChan, s);
	s.LoadString(IDS_TITLE_TALK);
	g_opt.sTalk = GetProfileString(szOptTitle, szTalk, s);
	s.LoadString(IDS_TITLE_CHAT);
	g_opt.sChat = GetProfileString(szOptTitle, szChat, s);

	// format
	g_opt.fMsgJoin = GetProfileInt(szOptMsg, szJoin, TRUE);
	g_opt.fMsgKick = GetProfileInt(szOptMsg, szKick, TRUE);
	g_opt.fMsgMode = GetProfileInt(szOptMsg, szMode, FALSE);
	g_opt.fMsgNick = GetProfileInt(szOptMsg, szNick, FALSE);
	g_opt.fMsgPart = GetProfileInt(szOptMsg, szPart, TRUE);
	g_opt.fMsgQuit = GetProfileInt(szOptMsg, szQuit, TRUE);
	g_opt.fMsgQuery = GetProfileInt(szOptMsg, szQuery, FALSE);
	g_opt.fMsgTopic = GetProfileInt(szOptMsg, szTopic, TRUE);
	g_opt.fMsgTime = GetProfileInt(szOptMsg, szTime, TRUE);
	s.LoadString(IDS_MSG_TIME);
	g_opt.sMsgTime = GetProfileString(szOptMsg, szTimeFmt, s);
	g_opt.sMsgNick = GetProfileString(szOptMsg, szNickFmt, DEF_MSGNICK);
	g_opt.fMsgReplyToMain = GetProfileInt(szOptMsg, szReplyToMain, FALSE);

	// events
	g_opt.fPrivMsgPopup = GetProfileInt(szOptEvent, szPrivMsgPopup, TRUE);
	g_opt.fPrivMsgWhois = GetProfileInt(szOptEvent, szPrivMsgWhois, FALSE);
	g_opt.nInvite = GetProfileInt(szOptEvent, szInvite, 0);
	g_opt.nDccChat = GetProfileInt(szOptEvent, szDccChat, 0);
	g_opt.fReconnect = GetProfileInt(szOptEvent, szReconnect, FALSE);
	g_opt.fRejoin = GetProfileInt(szOptEvent, szRejoin, TRUE);
	g_opt.fFlashInactive = GetProfileInt(szOptEvent, szFlashInactive, FALSE);
	g_opt.fFlashMinimized = GetProfileInt(szOptEvent, szFlashMinimized, TRUE);
	g_opt.fRestoreMinimized = GetProfileInt(szOptEvent, szRestoreMinimized, FALSE);
	//g_opt.fContinuousFlash = GetProfileInt(szOptEvent, szContinuousFlash, FALSE);

	// ison
	g_opt.fIsOnQuit = GetProfileInt(szOptIsOn, szIsOnQuit, FALSE);
	g_opt.fIsOnPopup = GetProfileInt(szOptIsOn, szIsOnPopup, TRUE);
	g_opt.nIsOnInterval = GetProfileInt(
		szOptIsOn, szIsOnInterval, ISON_DEF_INTERVAL);
	if (g_opt.nIsOnInterval < ISON_MIN_INTERVAL)
		g_opt.nIsOnInterval = ISON_MIN_INTERVAL;

	// beep
	optBeep.Load();

	// NickList
	OptLoadNickList();
	g_opt.nNLPos = GetProfileInt(szOptNickList, szPosition, NLPOS_RIGHT);

	// Keyword
	g_arKeyword.Load();
	g_opt.fKeywordWholeLine = GetProfileInt(szOptKeyword, szWholeLine, FALSE);
	g_opt.fRestoreByKeyword = GetProfileInt(szOptKeyword, szRestore, FALSE);

	// dcc
	g_opt.nDccSendPackets = GetProfileInt(szOptDcc, szDccSendPackets, 10);
	g_opt.nChatEOL = GetProfileInt(szOptDcc, szChatEOL, CHATEOL_LF);
	g_opt.nChatCode = GetProfileInt(szOptDcc, szChatCode, CHATCODE_JIS);

	g_opt.fUseDccFakeAddr = GetProfileInt(szOptDcc, szUseFakeAddr, FALSE);
	g_opt.fUseDccFakeAuto = GetProfileInt(szOptDcc, szUseFakeAuto, FALSE);

	s = GetProfileString(szOptDcc, szFakeAddr);
	g_opt.addrDccFakeAddr = inet_addr(s);
	if (g_opt.addrDccFakeAddr == INADDR_NONE)
		g_opt.fUseDccFakeAddr = FALSE;
	g_opt.nDccPort = GetProfileInt(szOptDcc, szPort, 0);

	// others
	g_opt.fDestNick = GetProfileInt(szOption, szDestNick, FALSE);
	g_opt.fMinimizeByReturnKey = GetProfileInt(szOption, szMinimizeByReturnKey, TRUE);
	g_opt.fIdentd = GetProfileInt(szOption, szIdentd, TRUE);
	g_opt.fConnectOnStartup = GetProfileInt(szOption, szConnectOnStartup, FALSE);
	g_fConv1ByteKana = GetProfileInt(szOption, szKana1Byte, TRUE);
	g_opt.fServerCollection = GetProfileInt(szOption, szServerCollection, FALSE);
	g_opt.fMinimizeMain = GetProfileInt(szOption, szMinimizeMain, TRUE);
	g_opt.fHideMain = GetProfileInt(szOption, szHideMain, TRUE);
	g_opt.fAutoSimple = GetProfileInt(szOption, szAutoSimple, FALSE);
	g_opt.fWhoisDetail = GetProfileInt(szOption, szWhoisDetail, TRUE);
	g_opt.fConfirmPaste = GetProfileInt(szOption, szConfirmPaste, TRUE);
	g_opt.fImeOn = GetProfileInt(szOption, szImeOn, FALSE);
	g_opt.sBrowser = GetProfileString(szOption, szBrowser);

	s = GetProfileString(szOption, szControlChar);
	g_opt.cCtrlChar = s.GetLength() > 0 ? s[0] : _T('!');
}

void OptSaveUser()
{
	theApp.WriteProfileString(szUserInfo, szNick, g_opt.sNick);
	theApp.WriteProfileString(szUserInfo, szNick2, g_opt.sNick2);
	theApp.WriteProfileString(szUserInfo, szNickAway, g_opt.sNickAway);
	theApp.WriteProfileString(szUserInfo, szRealName, g_opt.sRealName);
	theApp.WriteProfileString(szUserInfo, szUserInfo, g_opt.sUserInfo);
	theApp.WriteProfileString(szUserInfo, szLoginName, g_opt.sLoginName);
	theApp.WriteProfileString(szUserInfo, szHostname, g_opt.sHostName);
	CString s = g_opt.usermode.ToString();
	theApp.WriteProfileString(szUserInfo, szUserMode, s);
}

void OptSaveLog()
{
	theApp.WriteProfileInt(szOptLog, szLogMain, g_opt.fLogMain);
	theApp.WriteProfileInt(szOptLog, szLogChan, g_opt.fLogChan);
	theApp.WriteProfileInt(szOptLog, szLogTalk, g_opt.fLogTalk);
	theApp.WriteProfileString(szOptLog, szFileMain, g_opt.sFileMain);
	theApp.WriteProfileString(szOptLog, szDirChan, g_opt.sDirChan);
	theApp.WriteProfileString(szOptLog, szDirTalk, g_opt.sDirTalk);
	theApp.WriteProfileString(szOptLog, szLogExt, g_opt.sLogExt);
	theApp.WriteProfileInt(szOptLog, szAppend, g_opt.fAppend);
	theApp.WriteProfileInt(szOptLog, szDate, g_opt.fLogDate);
	theApp.WriteProfileString(szOptLog, szDateFormat, g_opt.sLogDateFormat);
	theApp.WriteProfileInt(szOptLog, szNewDate, g_opt.fLogNewDate);
	theApp.WriteProfileInt(szOption, szDebug, g_opt.fDebugLog);
}

void OptSaveTitle()
{
	theApp.WriteProfileString(szOptTitle, szMain, g_opt.sMain);
	theApp.WriteProfileString(szOptTitle, szChan, g_opt.sChan);
	theApp.WriteProfileString(szOptTitle, szTalk, g_opt.sTalk);
	theApp.WriteProfileString(szOptTitle, szChat, g_opt.sChat);
}

void OptSaveFormat()
{
	theApp.WriteProfileInt(szOptMsg, szJoin, g_opt.fMsgJoin);
	theApp.WriteProfileInt(szOptMsg, szKick, g_opt.fMsgKick);
	theApp.WriteProfileInt(szOptMsg, szMode, g_opt.fMsgMode);
	theApp.WriteProfileInt(szOptMsg, szNick, g_opt.fMsgNick);
	theApp.WriteProfileInt(szOptMsg, szPart, g_opt.fMsgPart);
	theApp.WriteProfileInt(szOptMsg, szQuit, g_opt.fMsgQuit);
	theApp.WriteProfileInt(szOptMsg, szQuery, g_opt.fMsgQuery);
	theApp.WriteProfileInt(szOptMsg, szTopic, g_opt.fMsgTopic);
	theApp.WriteProfileInt(szOptMsg, szTime, g_opt.fMsgTime);
	theApp.WriteProfileString(szOptMsg, szTimeFmt, g_opt.sMsgTime);
	theApp.WriteProfileString(szOptMsg, szNickFmt, g_opt.sMsgNick);
	theApp.WriteProfileInt(szOptMsg, szReplyToMain, g_opt.fMsgReplyToMain);
}

void OptSaveEvents()
{
	theApp.WriteProfileInt(szOptEvent, szPrivMsgPopup, g_opt.fPrivMsgPopup);
	theApp.WriteProfileInt(szOptEvent, szPrivMsgWhois, g_opt.fPrivMsgWhois);
	theApp.WriteProfileInt(szOptEvent, szInvite, g_opt.nInvite);
	theApp.WriteProfileInt(szOptEvent, szDccChat, g_opt.nDccChat);
	theApp.WriteProfileInt(szOptEvent, szReconnect, g_opt.fReconnect);
	theApp.WriteProfileInt(szOptEvent, szRejoin, g_opt.fRejoin);
	theApp.WriteProfileInt(szOptEvent, szFlashInactive, g_opt.fFlashInactive);
	theApp.WriteProfileInt(szOptEvent, szFlashMinimized, g_opt.fFlashMinimized);
	theApp.WriteProfileInt(szOptEvent, szRestoreMinimized, g_opt.fRestoreMinimized);
	//theApp.WriteProfileInt(szOptEvent, szContinuousFlash, g_opt.fContinuousFlash);
}

void OptSaveIsOn()
{
	theApp.WriteProfileInt(szOptIsOn, szIsOnQuit, g_opt.fIsOnQuit);
	theApp.WriteProfileInt(szOptIsOn, szIsOnPopup, g_opt.fIsOnPopup);
	theApp.WriteProfileInt(szOptIsOn, szIsOnInterval, g_opt.nIsOnInterval);
}

void OptSaveNickList()
{
	ArNLItem& ar = g_opt.arNLItem;
	CString s;
	int i;
	for (i = 0; i < ar.GetSize(); i++) {
		CString sNum;
		sNum.Format("%d ", ar[i]);
		s += sNum;
	}
	theApp.WriteProfileString(szOptNickList, szItems, s);
	theApp.WriteProfileInt(szOptNickList, szPosition, g_opt.nNLPos);
}

void OptSaveKeyword()
{
	g_arKeyword.Save();

	theApp.WriteProfileInt(szOptKeyword, szWholeLine, g_opt.fKeywordWholeLine);
	theApp.WriteProfileInt(szOptKeyword, szRestore, g_opt.fRestoreByKeyword);
}

void OptSaveDcc()
{
	theApp.WriteProfileInt(szOptDcc, szDccSendPackets, g_opt.nDccSendPackets);
	theApp.WriteProfileInt(szOptDcc, szChatEOL, g_opt.nChatEOL);
	theApp.WriteProfileInt(szOptDcc, szChatCode, g_opt.nChatCode);

	theApp.WriteProfileInt(szOptDcc, szUseFakeAddr, g_opt.fUseDccFakeAddr);
	theApp.WriteProfileInt(szOptDcc, szUseFakeAuto, g_opt.fUseDccFakeAuto);

	in_addr in;
	in.s_addr = g_opt.addrDccFakeAddr;
	char* p = inet_ntoa(in);
	theApp.WriteProfileString(szOptDcc, szFakeAddr, p);//delete if null

	theApp.WriteProfileInt(szOptDcc, szPort, g_opt.nDccPort);
}

void OptSaveOthers()
{
	theApp.WriteProfileInt(szOption, szDestNick, g_opt.fDestNick);
	theApp.WriteProfileInt(szOption, szMinimizeByReturnKey, g_opt.fMinimizeByReturnKey);
	theApp.WriteProfileInt(szOption, szIdentd, g_opt.fIdentd);
	theApp.WriteProfileInt(szOption, szConnectOnStartup, g_opt.fConnectOnStartup);
	theApp.WriteProfileInt(szOption, szKana1Byte, g_fConv1ByteKana);
	theApp.WriteProfileInt(szOption, szServerCollection, g_opt.fServerCollection);
	theApp.WriteProfileInt(szOption, szMinimizeMain, g_opt.fMinimizeMain);
	theApp.WriteProfileInt(szOption, szHideMain, g_opt.fHideMain);
	theApp.WriteProfileInt(szOption, szAutoSimple, g_opt.fAutoSimple);
	theApp.WriteProfileInt(szOption, szWhoisDetail, g_opt.fWhoisDetail);
	theApp.WriteProfileInt(szOption, szConfirmPaste, g_opt.fConfirmPaste);
	theApp.WriteProfileInt(szOption, szImeOn, g_opt.fImeOn);
	theApp.WriteProfileString(szOption, szBrowser, g_opt.sBrowser);
	theApp.WriteProfileString(szOption, szControlChar, CString(g_opt.cCtrlChar));
}
