// Setup.h : header file

#include "s_server.h"
#include "dlgres.h"

// Page: User

class SetupUser : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupUser)

// Construction
public:
	SetupUser();
	~SetupUser();

// Dialog Data
	//{{AFX_DATA(SetupUser)
	enum { IDD = IDD_USERSET };
	CString	m_sNick;
	CString	m_sRealName;
	CString	m_sUserInfo;
	CString	m_sLoginName;
	CString	m_sHostName;
	CString	m_sNick2;
	CString	m_sNickAway;
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SetupUser)
	public:
	virtual BOOL OnKillActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	BOOL NoOmit(UINT idc);
	BOOL NoSpace(UINT idc);
	BOOL No8Bit(UINT idc);
	void DecideNick2();

	// Generated message map functions
	//{{AFX_MSG(SetupUser)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnKillfocusNick();
	afx_msg void OnUsermode();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//
// Page: Log

class SetupLog : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupLog)

// Construction
public:
	SetupLog();
	~SetupLog();

// Dialog Data
	//{{AFX_DATA(SetupLog)
	enum { IDD = IDD_LOG };
	BOOL	m_fLogMain;
	BOOL	m_fLogTalk;
	CString	m_sFileMain;
	CString	m_sDirTalk;
	BOOL	m_fLogChan;
	CString	m_sDirChan;
	BOOL	m_fAppend;
	CString	m_sLogExt;
	BOOL	m_fLogDate;
	CString	m_sDateFormat;
	BOOL	m_fLogNewDate;
	BOOL	m_fDebugLog;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(SetupLog)
	public:
	virtual BOOL OnKillActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(SetupLog)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnLogMain();
	afx_msg void OnLogChan();
	afx_msg void OnLogTalk();
	afx_msg void OnLogDate();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	void DoCheckBox(int idCheck, int idEdit);
	BOOL Check(int nID, LPCTSTR pPath, BOOL fDir);
};

//
// Page: Title

class SetupTitle : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupTitle)

// Construction
public:
	SetupTitle();
	~SetupTitle();

// Dialog Data
	//{{AFX_DATA(SetupTitle)
	enum { IDD = IDD_TITLE };
	CString	m_sChan;
	CString	m_sMain;
	CString	m_sTalk;
	CString	m_sChat;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(SetupTitle)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(SetupTitle)
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// Page: Format

class SetupFormat : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupFormat)

// Construction
public:
	SetupFormat();
	~SetupFormat();

// Dialog Data
	//{{AFX_DATA(SetupFormat)
	enum { IDD = IDD_FORMAT };
	BOOL	m_fMsgJoin;
	BOOL	m_fMsgKick;
	BOOL	m_fMsgMode;
	BOOL	m_fMsgNick;
	BOOL	m_fMsgPart;
	BOOL	m_fMsgQuit;
	BOOL	m_fMsgTopic;
	BOOL	m_fMsgTime;
	CString	m_sMsgTime;
	BOOL	m_fMsgQuery;
	CString	m_sMsgNick;
	BOOL	m_fMsgReplyToMain;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(SetupFormat)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void UpdateState();

	// Generated message map functions
	//{{AFX_MSG(SetupFormat)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnMsgTime();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// Page: Event

class SetupEvent : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupEvent)

// Construction
public:
	SetupEvent();
	~SetupEvent();

	UINT m_nInvite;
	UINT m_nDccChat;

// Dialog Data
	//{{AFX_DATA(SetupEvent)
	enum { IDD = IDD_EVENTS };
	BOOL	m_fPrivMsgPopup;
	BOOL	m_fPrivMsgWhois;
	BOOL	m_fReconnect;
	BOOL	m_fRejoin;
	BOOL	m_fFlashInactive;
	BOOL	m_fFlashMinimized;
	BOOL	m_fRestoreMinimized;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(SetupEvent)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(SetupEvent)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// Page: Channels

class SetupChan : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupChan)

// Construction
public:
	SetupChan();
	~SetupChan();

// Dialog Data
	//{{AFX_DATA(SetupChan)
	enum { IDD = IDD_CHANNELS };
	CEdit	m_edChan;
	CButton	m_btDelete;
	CButton	m_btAppend;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(SetupChan)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CString m_sFile;
	CCheckListBox m_lbChan;
	BOOL m_fModify;

	// Generated message map functions
	//{{AFX_MSG(SetupChan)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnAppend();
	afx_msg void OnDelete();
	afx_msg void OnChangeChannel();
	afx_msg void OnSelChangeChannels();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// Page: Nicks

class SetupNicks : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupNicks)

public:
	SetupNicks();
	~SetupNicks();

	BOOL m_fChangeInterval;

	//{{AFX_DATA(SetupNicks)
	enum { IDD = IDD_ISON };
	CButton	m_btDelete;
	CButton	m_btAppend;
	CListBox	m_lbNick;
	CEdit	m_edNick;
	UINT	m_nInterval;
	BOOL	m_fPopup;
	//}}AFX_DATA


	//{{AFX_VIRTUAL(SetupNicks)
	public:
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);
	//}}AFX_VIRTUAL

protected:
	CStringArray m_asAdd;
	CStringArray m_asDel;

	//{{AFX_MSG(SetupNicks)
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeNick();
	afx_msg void OnSelchangeNicklist();
	afx_msg void OnAppend();
	afx_msg void OnDelete();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// Page: Beep

#include "lbBeep.h"

class SetupBeep : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupBeep)

public:
	SetupBeep();
	~SetupBeep();

	//{{AFX_DATA(SetupBeep)
	enum { IDD = IDD_BEEP };
	CStatic	m_stSoundFile;
	ClbBeep	m_lbBeep;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(SetupBeep)
	public:
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(SetupBeep)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// Page: Fonts

#include "fontbtn.h"

class SetupFonts : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupFonts)

// RXgNV
public:
	SetupFonts();
	~SetupFonts();

	//{{AFX_DATA(SetupFonts)
	enum { IDD = IDD_FONTS };
		//  - ClassWizard ͂̈ʒuɃf[^ oǉ܂B
		//    ̈ʒuɐR[hҏWȂłB
	//}}AFX_DATA

	//{{AFX_VIRTUAL(SetupFonts)
	public:
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	FontBtn m_arFontBtn[Fonts::NumberOfTypes];
	ColorBtn m_colorBtn;

	//{{AFX_MSG(SetupFonts)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	LONG OnBkColorChange(UINT wParam, LONG lParam);
	DECLARE_MESSAGE_MAP()

};

// SetupDcc _CAO

class SetupDcc : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupDcc)

// RXgNV
public:
	SetupDcc();
	~SetupDcc();

// _CAO f[^
	//{{AFX_DATA(SetupDcc)
	enum { IDD = IDD_SETUPDCC };
	CButton	m_btnUseDccFakeAuto;
	CEdit	m_edDccFakeAddr;
	CButton	m_btnUseDccFakeAddr;
	UINT	m_nDccSendPackets;
	UINT	m_nDccPort;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(SetupDcc)
	public:
	virtual void OnOK();
	virtual BOOL OnKillActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	// ꂽbZ[W }bv֐
	//{{AFX_MSG(SetupDcc)
	virtual BOOL OnInitDialog();
	afx_msg void OnUseDccFakeAddr();
	afx_msg void OnUseDccFakeAuto();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	BOOL m_fUse;
	BOOL m_fAuto;
	u_long m_nAddr;
	BOOL GetFakeAddr(BOOL fCheckValid = FALSE);
};

// Page: Others

class SetupOthers : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupOthers)

// Construction
public:
	SetupOthers();
	~SetupOthers();

// Dialog Data
	//{{AFX_DATA(SetupOthers)
	enum { IDD = IDD_OPTION };
	CButton	m_btBrowser;
	BOOL	m_fDestNick;
	BOOL	m_fIdentd;
	BOOL	m_fConnectOnStartup;
	BOOL	m_fServerCollection;
	CString	m_sCtrlChar;
	BOOL	m_fMinimizeByReturnKey;
	BOOL	m_fHideMain;
	BOOL	m_fMinimizeMain;
	BOOL	m_fWhoisDetail;
	BOOL	m_fConfirmPaste;
	BOOL	m_fImeOn;
	//}}AFX_DATA

	CString m_sBrowser;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(SetupOthers)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(SetupOthers)
	virtual void OnOK();
	virtual BOOL OnInitDialog();
	afx_msg void OnBrowser();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//
// Page: NickList

class SetupNicklist : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupNicklist)

// RXgNV
public:
	SetupNicklist();
	~SetupNicklist();

// _CAO f[^
	//{{AFX_DATA(SetupNicklist)
	enum { IDD = IDD_NICKLIST };
	CButton	m_btDown;
	CButton	m_btUp;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐𐶐I[o[Ch܂B
	//{{AFX_VIRTUAL(SetupNicklist)
	public:
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CCheckListBox m_lbItem;
	BOOL m_fModify;
	UINT m_nPosition;

	void UpDown();
	void Move(int nFrom, int nTo);

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(SetupNicklist)
	virtual BOOL OnInitDialog();
	afx_msg void OnNicklistUp();
	afx_msg void OnNicklistDown();
	afx_msg void OnSelchangeNicklistItem();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

// SetupKeyword _CAO

class SetupKeyword : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupKeyword)

// RXgNV
public:
	SetupKeyword();
	~SetupKeyword();

// _CAO f[^
	//{{AFX_DATA(SetupKeyword)
	enum { IDD = IDD_KEYWORD };
	CListBox	m_lsKeyword;
	CButton	m_btDelete;
	CButton	m_btAppend;
	CEdit	m_edKeyword;
	BOOL	m_fKeywordWholeLine;
	BOOL	m_fKeywordRestore;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(SetupKeyword)
	public:
	virtual void OnOK();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	// ꂽbZ[W }bv֐
	//{{AFX_MSG(SetupKeyword)
	virtual BOOL OnInitDialog();
	afx_msg void OnChangeKeyword();
	afx_msg void OnKeywordAppend();
	afx_msg void OnKeywordDelete();
	afx_msg void OnSelchangeListKeyword();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// SetupPlug _CAO

class SetupPlug : public CPropertyPage
{
	DECLARE_DYNCREATE(SetupPlug)

// RXgNV
public:
	SetupPlug();
	~SetupPlug();

// _CAO f[^
	//{{AFX_DATA(SetupPlug)
	enum { IDD = IDD_PLUG };
	CButton	m_btProperty;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(SetupPlug)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	CCheckListBox	m_lbPlug;
	void EnableProperty();

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(SetupPlug)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangePluglist();
	afx_msg void OnProperty();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//
// Sheet: Setup
class CSetup : public CPropertySheet
{
	DECLARE_DYNAMIC(CSetup)

// Construction
public:
	//CSetup(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);
	CSetup();

// Attributes
public:
	SetupServer m_server;
	SetupUser m_user;
	SetupLog m_log;
	SetupTitle m_title;
	SetupFormat m_format;
	SetupEvent m_event;
	SetupChan m_chan;
	SetupNicks m_nicks;
	SetupBeep m_beep;
	SetupFonts m_fonts;
	SetupNicklist m_nicklist;
	SetupKeyword m_keyword;
	SetupDcc m_dcc;
	SetupPlug m_plug;
	SetupOthers m_others;

// Operations
public:
	void UpdateTitle() { m_fUpdateTitle = TRUE; }
protected:
	BOOL m_fUpdateTitle;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSetup)
	public:
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSetup();

	// Generated message map functions
protected:
	//{{AFX_MSG(CSetup)
	afx_msg void OnDestroy();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

// DlgUserMode _CAO

class DlgUserMode : public CDialog
{
// RXgNV
public:
	DlgUserMode(CWnd* pParent = NULL);   // W̃RXgN^

// _CAO f[^
	//{{AFX_DATA(DlgUserMode)
	enum { IDD = IDD_USERMODE };
	BOOL	m_fInvisible;
	BOOL	m_fWallops;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B

	//{{AFX_VIRTUAL(DlgUserMode)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(DlgUserMode)
	virtual void OnOK();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
